﻿define([
    // Dojo
    "dojo/_base/declare",
    "dojo/store/Memory",
    "dojo/store/JsonRest",
    "dijit/registry",
    // Dijit
    "dijit/_TemplatedMixin",
    "dijit/_Container",
    "dijit/layout/_LayoutWidget",
    "dijit/form/ComboBox",
    "dijit/form/TextBox",
    "dijit/form/DateTextBox",
    //"dijit/layout/_ContentPane",
    "dijit/_WidgetsInTemplateMixin",
    "epi-cms/_ContentContextMixin",
    "epi/dependency",
    "epi/routes",
    "epi/shell/command/_WidgetCommandProviderMixin",
    //custom
    //"jQuery",
    "dojo/text!./asseterrorlogs.html"
], function (
    // Dojo
    declare,
    Memory,
    JsonRest,
    registry,
    // Dijit
    _TemplatedMixin,
    _Container,
    _LayoutWidget,
    ComboBox,
    TextBox,
    DateTextBox,
    _WidgetsInTemplateMixin,
    _ContentContextMixin,
    dependency,
    routes,
    _WidgetCommandProviderMixin,
    //$,
    template
) {

        return declare(
            [_Container, _LayoutWidget, _TemplatedMixin, _WidgetsInTemplateMixin, _ContentContextMixin, _WidgetCommandProviderMixin], {
                templateString: template,
                widgetsInTemplate: true,
                store: null,
                context: null,

                contextChanged: function (context, callerData) {
                    this.context = context;
                    this.inherited(arguments);
                },

                _getRestPath: function (name) {
                    return routes.getRestPath({ moduleArea: "lionbridgeconnector", storeName: name });
                },

                _store: function () {
                    var registry = dependency.resolve("epi.storeregistry");
                    if (registry._stores["workspace.workspacestore"] === undefined) {
                        registry.create("workspace.asseterrorlogsstore", this._getRestPath("asseterrorlogsstore"));
                        registry.create("workspace.translationprojectasseterrorlogsliststore", this._getRestPath("translationprojectasseterrorlogsliststore"));
                        registry.create("workspace.selecttranslationprojectasssetliststore", this._getRestPath("selecttranslationprojectasssetliststore"));

                    }

                    this.store = this.store || registry.get("workspace.workspacestore");
                    return this.store;
                },


                startup: function () {
                    var self = this;
                    self.inherited(arguments);
                    this._store();

                    LionBridgeAssetConnectorJs.selectAssetStatusServiceUrl = window.location.origin +
                        this._getRestPath("selecttranslationprojectasssetliststore");
                    LionBridgeAssetConnectorJs.assetErrorLogServiceUrl = window.location.origin +
                        this._getRestPath("translationprojectasseterrorlogsliststore");

                    //Object dojo
                    LionBridgeAssetConnectorJs.dependency = dependency;

                    //Data for Asset status combobox
                    var assetStatusStore = new Memory();
                    var assetTypesStore = new Memory();
                    var assetErrorTypesStore = new Memory();
                    var assetLanguagesStore = new Memory();
                    var assetDeliveryStore = new Memory();

                    var asStore = new JsonRest({
                        target: LionBridgeAssetConnectorJs.selectAssetStatusServiceUrl
                    });

                    asStore.query().then(function (results) {
                        assetStatusStore.add({ name: "All", id: "" });

                        if (results !== null && results.assetStatues !== null) {
                            var assetStatues = results.assetStatues;
                            if (assetStatues)
                            for (var i = 0; i < assetStatues.length; i++) {
                                assetStatusStore.add({ name: assetStatues[i].text, id: assetStatues[i].value });
                            }
                        }

                        assetTypesStore.add({ name: "All", id: "" });
                        if (results !== null && results.assetTypes !== null) {
                            var assetTypes = results.assetTypes;
                            if (assetTypes)
                            for (var j = 0; j < assetTypes.length; j++) {
                                assetTypesStore.add({ name: assetTypes[j].text, id: assetTypes[j].value });
                            }
                        }

                        assetErrorTypesStore.add({ name: "All", id: "" });
                        assetErrorTypesStore.add({ name: "None", id: "None" });
                        assetErrorTypesStore.add({ name: "Translation Error", id: "Translation Error" });
                        assetErrorTypesStore.add({ name: "Sending Error", id: "Sending Error" });
                        assetErrorTypesStore.add({ name: "Importing Error", id: "Importing Error" });
                        assetErrorTypesStore.add({ name: "Publishing Error", id: "Publishing Error" });
                        assetErrorTypesStore.add({ name: "Other Error", id: "Other Error" });

                        assetLanguagesStore.add({ name: "All", id: "" });
                        if (results !== null && results.languages !== null) {
                            if (results.languages)
                                for (var j = 0; j < results.languages.length; j++) {
                                    assetLanguagesStore.add({ name: results.languages[j].text, id: results.languages[j].value });
                                }
                        }

                        assetDeliveryStore.add({ name: "All", id: "" });
                        assetDeliveryStore.add({ name: "Yes", id: "Yes" });
                        assetDeliveryStore.add({ name: "No", id: "No" });

                        LionBridgeAssetErrorLogsGrid.ComboBox = ComboBox;
                        LionBridgeAssetErrorLogsGrid.TextBox = TextBox;
                        LionBridgeAssetErrorLogsGrid.DateTextBox = DateTextBox;
                        LionBridgeAssetErrorLogsGrid.assetStatusDataStore = assetStatusStore;
                        LionBridgeAssetErrorLogsGrid.assetTypesDataStore = assetTypesStore;
                        LionBridgeAssetErrorLogsGrid.assetErrorTypesStore = assetErrorTypesStore;
                        LionBridgeAssetErrorLogsGrid.assetLanguagesStore = assetLanguagesStore;
                        LionBridgeAssetErrorLogsGrid.assetDeliveryStore = assetDeliveryStore;

                        $n.fn.DataTable.ext.search.push(
                            function (settings, data, dataIndex) {
                                var min = minCreatedDate;
                                var max = maxCreatedDate;
                                var date = new Date(data[6]).getTime();

                                if (
                                    (!min && !max ) ||
                                    (!min && date <= max) ||
                                    (min <= date && !max) ||
                                    (min <= date && date <= max)
                                ) {
                                    return true;
                                }
                                return false;
                            }
                        );
                        LionBridgeAssetErrorLogsGrid.onRenderGrid();
                        LionBridgeAssetErrorLogsGrid.onRegisterClass();

                    });

                },
                postCreate: function () { }
            });
    });

//var $ = jQuery.noConflict(true);
var minCreatedDate;
var maxCreatedDate;

var LionBridgeAssetConnectorConstant = LionBridgeAssetConnectorConstant || (function () {

    return {
    };
})();

var LionBridgeAssetConnectorJs = LionBridgeAssetConnectorJs || (function () {

    function onExportCsv() {
        var registry = LionBridgeAssetConnectorJs.dependency.resolve("epi.storeregistry");
        var store = registry.get("workspace.translationprojectasseterrorlogsliststore");

        var queryPrams = LionBridgeAssetErrorLogsGrid.queryPrams;

        store.put(JSON.stringify(queryPrams)).then(function (item) {
            if (item.error) {
                var errorDialog = new LionBridgeAssetConnectorJs.Alert({
                    heading: "Asset logs not exported",
                    description: "Something went wrong when exporting the asset logs due to: " + item.errorMessage
                });
                errorDialog.show();
            } else {

                var binaryString = window.atob(item.result);
                var len = binaryString.length;
                var bytes = new Uint8Array(len);
                for (var i = 0; i < len; i++) {
                    bytes[i] = binaryString.charCodeAt(i);
                }

                var blob = new Blob([bytes.buffer], { type: 'text/plain' });
                if (window.navigator && window.navigator.msSaveOrOpenBlob) {
                    window.navigator.msSaveOrOpenBlob(blob);
                } else {
                    var objectUrl = URL.createObjectURL(blob);
                    var anchor = document.createElement("a");
                    anchor.download = 'AssetErrorlog' + new Date().toLocaleString() + '.csv';
                    anchor.href = objectUrl;
                    anchor.click();
                }
            }
        });
    }

    //Service
    var assetErrorLogServiceUrl;
    var dependency;

    return {
        //Service
        assetErrorLogServiceUrl: assetErrorLogServiceUrl,
        dependency: dependency,
        onExportCsv: onExportCsv
    };
})();


var LionBridgeAssetErrorLogsGrid = LionBridgeAssetErrorLogsGrid || (function () {
    var pageSize = 20;
    var assetErrorLogsTable;
    var projectDataStore;
    var assetStatusDataStore;
    var assetTypesDataStore;
    var assetErrorTypesStore;
    var assetLanguagesStore;
    var assetDeliveryStore;
    var defaultSortColumnNumber = 6;
    var dateColumnNumber = 6;
    var loaded = false;

    var queryPrams = {
        AssetName: null,
        //Type: null,
        ProjectName: null,
        Status: null,
        FromCreatedDate: null,
        ToCreatedDate: null,
        HasError: null,
        IsArchived: false,
        ErrorType: null,
        Language: null,
        Delivery: null
    };

    function onRenderGrid() {

        var AssetColumnSize = [];

        AssetColumnSize["Request ID"] = "250px";
        //AssetColumnSize["Type"] = "60px";
        AssetColumnSize["Project Name"] = "200px";
        AssetColumnSize["Language"] = "60px";
        AssetColumnSize["Error Type"] = "70px";
        AssetColumnSize["Asset Status"] = "70px";
        AssetColumnSize["Delivery"] = "70px";
        AssetColumnSize["Log Details"] = "300px";
        AssetColumnSize["Created"] = "200px";       
  

        $n('#asseterrorlog702ff2e674297a14add329bda9c7e thead tr')
            .clone(true)
            .addClass('filters')
            .appendTo('#asseterrorlog702ff2e674297a14add329bda9c7e thead');

        
        $n('#asseterrorlog702ff2e674297a14add329bda9c7e thead tr.filters')[0].hidden = true;

        LionBridgeAssetErrorLogsGrid.assetErrorLogsTable = $n('#asseterrorlog702ff2e674297a14add329bda9c7e').DataTable({
            //"fixedHeader": true,
            "processing": true,
            "language": {
                "loadingRecords": "&nbsp;",
                "processing": "Loading..."
            },
            "retrieve": true,
            "lengthChange": false,
            //"fixedColumns": true,
            "pageLength": pageSize,
            "autoWidth": false,
            "orderCellsTop": true,
            //"searching": true,
            //language: { search: "" },
            //"serverSide": true,
            //"info": false,
            "initComplete": function () {
                
                $n('#asseterrorlog702ff2e674297a14add329bda9c7e thead tr.filters')[0].hidden = false;
                var api = this.api();                
                api.columns()
                    .eq(0)
                    .each(function (colIdx) {
                        var cell = $n('.filters th').eq(
                            $n(api.column(colIdx).header()).index()
                        );
                        var title = $n(cell).text();
                        var removedijitInputField = function (domItem) {
                            let domItems = domItem.domNode.getElementsByClassName('dijitInputField');
                            let length = domItems.length;
                            while (length--) {
                                domItems[length].classList.remove('dijitInputField');
                            }

                        };
                        var editCssArrowBox = function (domItem) {
                            let domItems = domItem.domNode.getElementsByClassName('dijitArrowButtonContainer');
                            let length = domItems.length;
                            while (length--) {
                                domItems[length].style.padding = '0px';
                                domItems[length].style.lineHeight = '24px';
                            }
                        }
                        switch (colIdx) {
                            case 0:
                                {
                                    $n(cell).html('<input id="requestId" />');
                                    var requestIdTextBox = new LionBridgeAssetErrorLogsGrid.TextBox({
                                        name: "requestId",
                                        value: "",
                                        style: { 'width': "90%"},
                                        placeHolder: title
                                    }, "requestId");
                                    requestIdTextBox.startup();
                                    removedijitInputField(requestIdTextBox);
                                    break;
                                }
                            case 1:
                                {
                                    $n(cell).html('<input id="jobName" />');
                                    var jobNameTextBox = new LionBridgeAssetErrorLogsGrid.TextBox({
                                        name: "jobName",
                                        value: "",
                                        style: { 'width': "90%" },
                                        placeHolder: title
                                    }, "jobName");
                                    jobNameTextBox.startup();
                                    removedijitInputField(jobNameTextBox);
                                    break;
                                }
                            case 2:
                                {
                                    $n(cell).html('<select id="cbAssetLanguage" ><option value="">All</option></select>');

                                    var assetLanguageComboBox = new LionBridgeAssetErrorLogsGrid.ComboBox({
                                        id: "cbAssetLanguage",
                                        value: "",
                                        store: LionBridgeAssetErrorLogsGrid.assetLanguagesStore,
                                        searchAttr: "name",
                                        style: { 'width': "90%" },
                                        placeHolder: title,
                                        onChange: function (type) {
                                            if (type == 'All')
                                                this.textbox.value = '';
                                            $n(this.textbox).change();
                                        }
                                    }, "cbAssetLanguage");
                                    assetLanguageComboBox.startup();
                                    removedijitInputField(assetLanguageComboBox);
                                    editCssArrowBox(assetLanguageComboBox);
                                    break;
                                }
                            case 3:
                                {
                                    $n(cell).html('<select id="cbAssetErrorType" ><option value="">All</option></select>');

                                    var assetErrorComboBox = new LionBridgeAssetErrorLogsGrid.ComboBox({
                                        id: "cbAssetErrorType",
                                        value: "",
                                        store: LionBridgeAssetErrorLogsGrid.assetErrorTypesStore,
                                        searchAttr: "name",
                                        style: { 'width': "90%" },
                                        placeHolder: title,
                                        onChange: function (type) {
                                            if (type == 'All')
                                                this.textbox.value = '';
                                            $n(this.textbox).change();
                                        }
                                    }, "cbAssetErrorType");
                                    assetErrorComboBox.startup();
                                    removedijitInputField(assetErrorComboBox);
                                    editCssArrowBox(assetErrorComboBox);
                                    break;
                                }
                            case 4:
                                {
                                    $n(cell).html('<select id="cbAssetStatus" ><option value="">All</option></select>');

                                    var statusComboBox = new LionBridgeAssetErrorLogsGrid.ComboBox({
                                        id: "cbAssetStatus",
                                        value: "",
                                        store: LionBridgeAssetErrorLogsGrid.assetStatusDataStore,
                                        searchAttr: "name",
                                        style: { 'width': "90%" },
                                        placeHolder: title,
                                        onChange: function (type) {
                                            if (type == 'All')
                                                this.textbox.value = '';
                                            $n(this.textbox).change();
                                        }
                                    }, "cbAssetStatus");
                                    statusComboBox.startup();
                                    removedijitInputField(statusComboBox);
                                    editCssArrowBox(statusComboBox);
                                    break;
                                }
                            case 5:
                                {
                                    $n(cell).html('<select id="cbAssetDelivery" ><option value="">All</option></select>');

                                    var assetDeliveryComboBox = new LionBridgeAssetErrorLogsGrid.ComboBox({
                                        id: "cbAssetDelivery",
                                        value: "",
                                        style: { 'width': "90%" },
                                        store: LionBridgeAssetErrorLogsGrid.assetDeliveryStore,
                                        searchAttr: "name",
                                        placeHolder: title,
                                        onChange: function (type) {
                                            if (type == 'All')
                                                this.textbox.value = '';
                                            $n(this.textbox).change();
                                        }
                                    }, "cbAssetDelivery");
                                    assetDeliveryComboBox.startup();
                                    removedijitInputField(assetDeliveryComboBox);
                                    editCssArrowBox(assetDeliveryComboBox);
                                    break;
                                }
                            case 6:
                                {
                                    $n(cell).html( '<label for="fromServerValue">From:</label>' +
                                        '<input id="fromServerValue" readonly="readonly" disabled="disabled" /><br />' +
                                        '<label for="toServerValue">To:</label>' +
                                        '<input id="toServerValue" readonly="readonly" disabled="disabled" />');

                                    var fromDateTextBox = new LionBridgeAssetErrorLogsGrid.DateTextBox({
                                        value: undefined,
                                        style: { 'width': "60%", 'margin-left': "5%" },
                                        name: "fromServerValue",
                                        placeHolder: 'mm/dd/yyyy',
                                        //oracleFormat: { selector: 'date', datePattern: 'MM/dd/yyyy', locale: 'en-us' },
                                        onChange: function (type) {
                                            //$n(this.textbox).change();
                                            minCreatedDate = new Date(type).getTime();
                                            api.draw();
                                        }
                                    }, "fromServerValue");
                                    
                                    var toDateTextBox = new LionBridgeAssetErrorLogsGrid.DateTextBox({
                                        value: undefined,
                                        style: { 'width': "60%", 'margin-left': "13%" },
                                        name: "toServerValue",
                                        placeHolder: 'mm/dd/yyyy',
                                        onChange: function (type) {
                                            //$n(this.textbox).change();
                                            maxCreatedDate = new Date(type).getTime();
                                            api.draw();
                                        }
                                    }, "toServerValue");
                                    fromDateTextBox.startup();
                                    toDateTextBox.startup();
                                    removedijitInputField(fromDateTextBox);
                                    removedijitInputField(toDateTextBox);
                                    editCssArrowBox(fromDateTextBox);
                                    editCssArrowBox(toDateTextBox);
                                    break;
                                }
                            default:
                                $n(cell).html('<input type="text" style="display:none"/>');
                        }
                        if (colIdx == 6)
                            return;
                        // On every keypress in this input
                        $n(
                            '.dijitInputInner',
                            $n('.filters th').eq($n(api.column(colIdx).header()).index())
                        )
                            .off('keyup change')
                            .on('change', function (e) {
                                // Get the search value
                                $n(this).attr('title', $n(this).val());
                                var regexr = '({search})'; //$n(this).parents('th').find('select').val();

                                var cursorPosition = this.selectionStart;
                                // Search the column for that value
                                api
                                    .column(colIdx)
                                    .search(
                                        this.value != ''
                                            ? regexr.replace('({search})', this.value)
                                            : '',
                                        this.value != '',
                                        this.value == ''
                                    )
                                    .draw();
                            })
                            .on('keyup', function (e) {
                                e.stopPropagation();

                                $n(this).trigger('change');
                                $n(this)
                                    .focus()[0]
                                    .setSelectionRange(cursorPosition, cursorPosition);
                            });
                    });
            },
            "ajax": {
                "url": LionBridgeAssetConnectorJs.assetErrorLogServiceUrl,
                //"data": function (d) {
                //    if (d.order.length > 0) {
                //        if (d.order[0].column === dateColumnNumber) {
                //            d.ordercolumn = d.columns[d.order[0].column].name;
                //        } else {
                //            d.ordercolumn = d.columns[d.order[0].column].data;
                //        }

                //        d.orderBy = d.order[0].dir;
                //    }

                //    //if (queryPrams.Type === "All") {
                //    //    queryPrams.Type = null;
                //    //}

                //    if (queryPrams.Status === "All") {
                //        queryPrams.Status = null;
                //    }

                //    if (queryPrams.ErrorType === "All") {
                //        queryPrams.ErrorType = null;
                //    }

                //    if (queryPrams.Language === "All") {
                //        queryPrams.Language = null;
                //    }

                //    if (queryPrams.Delivery === "All") {
                //        queryPrams.Delivery = null;
                //    }

                //    d.search = JSON.stringify(queryPrams);

                //    d.order = '';
                //    d.columns = '';

                //},
            },
            "columns": [
                { "data": "name", "className": "assetname", "width": "8%"},
                //{ "data": "type", "className": "type", "width": "60px" },
                { "data": "projectName", "className": "projectname", "width": "8%" },
                { "data": "language", "className": "language", "width": "8%" },
                { "data": "errorType", "className": "errorType", "width": "8%" },
                { "data": "status", "className": "status", "width": "8%" },
                { "data": "delivery", "className": "delivery", "width": "8%" },
                {
                    "data": "created.display",
                    "className": "created",
                    "width": "8%"
                },
                { "data": "errorDetails", "className": "errordetails", "width": "12%" },
                {
                    "data": "created.timestamp",
                    "className": "created"
                }
            ],
            "columnDefs": [
                {
                    "targets": [0],
                    "render": asset_cell_assetname_render
                },
                {
                    "targets": [6],
                    "render": asset_cell_datetime_render,
                    "orderData": [8]
                },
                {
                    "targets": [7],
                    "orderable": false
                },
                {
                    "targets": [8],
                    "orderable": false,
                    "visible": false,
                    "searchable": false
                }
            ],
            "order": [[6, "desc"]],
        });

        //loaded = true;
        //$n('div.dataTables_filter').hide();
        $n('div.dataTables_filter')[0].hidden = true;

        function asset_cell_assetname_render(data, type, row, meta) {
            if (row.link === undefined || row.link === '')
                return '';

            return '<a href="' + row.link + '" rel="nofollow" target="_blank" status="' + row.status + '" assetId="' + row.assetID + '">' + row.name + '</a>';
        }

        function asset_cell_datetime_render(data, type, row, meta) {
            
            return '<span style="white-space: normal; max-width:230px; display: block">' + new Date(row.created.display) + '</span>';
        }

    }

    function onReloadGrid() {
        if (LionBridgeAssetErrorLogsGrid !== undefined && LionBridgeAssetErrorLogsGrid.assetErrorLogsTable !== undefined) {

            LionBridgeAssetErrorLogsGrid.assetErrorLogsTable.ajax.reload();
            LionBridgeAssetErrorLogsGrid.assetErrorLogsTable.order([defaultSortColumnNumber, 'desc']).draw();
        }
    }

    function destroy() {
        if ($n.fn.DataTable.isDataTable("#asseterrorlog702ff2e674297a14add329bda9c7e")) {
            LionBridgeAssetErrorLogsGrid.assetErrorLogsTable.clear().destroy();
        }
    }

    function onReset() {

        $n('#assetName').val("");
        $n('#projectName').val("");
        $n('#cbAssetStatus').val("");
        //$n('#cbAssetType').val("All");
        $n('#fromCreatedDate').val("");
        $n('#toCreatedDate').val("");
        $n('#cbAssetErrorType').val("");
        $n('#cbAssetLanguage').val("");
        $n('#cbAssetDelivery').val("");
        $n('#fromServerValue').val("");
        $n('#toServerValue').val("");

        minCreatedDate = null;
        maxCreateDate = null;

        queryPrams = {
            AssetName: null,
            Type: null,
            ProjectName: null,
            Status: null,
            FromCreatedDate: null,
            ToCreatedDate: null,
            HasError: null,
            IsArchived: false,
            ErrorType: null,
            Language: null,
            Delivery: null
        };

        if (LionBridgeAssetErrorLogsGrid !== undefined &&
            LionBridgeAssetErrorLogsGrid.assetErrorLogsTable !== undefined) {

            LionBridgeAssetErrorLogsGrid.assetErrorLogsTable.ajax.reload();
            LionBridgeAssetErrorLogsGrid.assetErrorLogsTable.order([defaultSortColumnNumber, 'desc']).draw();
        }
    }

    function refreshChildGrid(item) {
        var table = $n(item).closest('table');
        if (table !== undefined)
            table.DataTable().ajax.reload();
    }

    function onRegisterClass() {
        var form = $n('#asseterrorlog702ff2e674297a14add329bda9c7e').closest('form');
        if (!$n(form).hasClass('lb_asset_error_log'))
            $n(form).addClass('lb_asset_error_log');

        var body = $n('#asseterrorlog702ff2e674297a14add329bda9c7e').closest('body');
        if (!$n(body).hasClass('lb_body_asset_error_log'))
            $n(body).addClass('lb_body_asset_error_log');
    }

    return {
        onRenderGrid: onRenderGrid,
        projectDataStore: projectDataStore,
        assetStatusDataStore: assetStatusDataStore,
        assetTypesDataStore: assetTypesDataStore,
        assetErrorTypesStore: assetErrorTypesStore,
        assetLanguagesStore: assetLanguagesStore,
        assetDeliveryStore: assetDeliveryStore,
        assetErrorLogsTable: assetErrorLogsTable,
        destroy: destroy,
        onReloadGrid: onReloadGrid,
        refreshChildGrid: refreshChildGrid,
        onReset: onReset,
        onRegisterClass: onRegisterClass,
        queryPrams: queryPrams
    };
})();