﻿define([
    "dojo/_base/declare",
    "dojo/on",
    "epi/shell/command/_Command",
    "epi/shell/_ContextMixin",
    "epi/dependency",
    "dojo/text!../epi-modal.html"
], function (declare, on, _Command, _ContextMixin, dependency, template) {

    return declare([_Command, _ContextMixin], {
        contentQuery: null,
        label: "Create New Translation Job",
        iconClass: "epi-iconPlus",

        constructor: function () {
            // Set the model to the initial context.
            this.set("model", this._currentContext);
        },

        _execute: function () {
            let hideAll = function () {               
                dojo.destroy('niteco-epi-modal');
                dojo.destroy('niteco-epi-hidden-layout');
            }
            var registry = dependency.resolve("epi.storeregistry");
            if (registry._stores["workspace.lionjobstore"] === undefined) {
                registry.create("workspace.lionjobstore", this._getRestPath("lionjobstore"));
            }
            var x = this.contentQuery;
            var store = registry.get("workspace.lionjobstore");
            x.store = store;

            let hiddenLayout = dojo.byId('niteco-epi-hidden-layout');
            
            if (!hiddenLayout) {
                dojo.body().insertAdjacentHTML("beforeEnd", template);
                hiddenLayout = dojo.byId('niteco-epi-hidden-layout');
            }
            else
                hideAll();

            let okBtn = dojo.byId('niteco-epi-ok-button');
            let cancelBtn = dojo.byId('niteco-epi-cancel-button');
            let closeTextBtn = dojo.byId('niteco-epi-close-text');

            on(cancelBtn, 'click', function (evt) {
                hideAll();
            });

            on(closeTextBtn, 'click', function (evt) {
                hideAll();
            });
            
            on(okBtn, 'click', function (evt) {
                let proName = dojo.byId('niteco-epi-name-field').value;
                hideAll();
                $n('.loadingDiv').fadeIn(500);
                store.put({
                    action: "create",
                    jobName: proName
                }).then(function (item) {
                    //x.set("queryParameters", { workspace: 1, page: 1 });
                    //x.set("queryName", "WorkspaceQuery");
                    LionBridgeConnectorGadget.sortGadgetSe();

                    if (typeof LionBridgeConnectorGrid !== "undefined" && typeof LionBridgeConnectorJs !== "undefined") {
                        LionBridgeConnectorGrid.clearFilter();
                        LionBridgeConnectorJs.onSetArchiving(true);
                        LionBridgeConnectorGrid.onToggleArchivingView('#archive6bb3b40543354773812682476d110c8f');
                        //LionBridgeConnectorGrid.onReloadGrid();
                    }

                    if (item !== undefined && item.itemLink !== undefined && item.itemLink !== '') {
                        window.location.href = item.itemLink;
                    }
                    $n('.loadingDiv').fadeOut(500);
                }, function (err) {
                    console.log('error');
                });
            });

        },

        _onModelChange: function () {
            this.set("canExecute", !!this.model);
        },

        contextChanged: function (context) {
            // Update the model to the new context when it changes.
            this.set("model", context);
        }
    });
})