﻿define([
    "dojo/_base/declare",
        "epi/dependency",
            "epi/routes",
    "epi/shell/widget/dialog/Alert",
    "epi/shell/command/_Command"
], function (declare, dependency, routes, Alert, _Command) {

    return declare([_Command], {
        store: null,
        contentQuery: null,

        label: "Import translations",
        iconClass: "epi-iconDownload",
        category: "context",

        _execute: function () {
            
            var registry = dependency.resolve("epi.storeregistry");
            this.store = registry.get("workspace.lionjobstore");
            var selfCom = this;
            $(selfCom.lionElement).addClass("disable-job-gadget");
            dojo.when(this.store.put({
                id: this.model.contentLink,
                action: 'import'
            }), function (item) {
                if (item.error) {
                    var errorDialog = new Alert({
                        heading: "Job not sent",
                        description: "Something went wrong when importing the job: " + item.errorMessage
                    });
                    errorDialog.show();
                }
                else {
                    var dialog = new Alert({
                        heading: "Imported",
                        description: "The job has been imported, but has not been published. Please review the translations."
                    });
                    dialog.show();

                    if (typeof LionBridgeConnectorGrid !== "undefined") {
                        LionBridgeConnectorGrid.onReloadGrid();
                    }
                }
                $(selfCom.lionElement).removeClass("disable-job-gadget");
                //selfCom.contentQuery.set("queryParameters", { workspace: 1, page: 1 });
                //selfCom.contentQuery.set("queryName", "WorkspaceQuery");
                LionBridgeConnectorGadget.sortGadgetSe();
            }, function (err) {
                $(selfCom.lionElement).removeClass("disable-job-gadget");
                //selfCom.contentQuery.set("queryParameters", { workspace: 1, page: 1 });
                //selfCom.contentQuery.set("queryName", "WorkspaceQuery");
                LionBridgeConnectorGadget.sortGadgetSe();
            });

            //this.contentQuery.set("queryParameters", { workspace: 1, page: 1 });
            //this.contentQuery.set("queryName", "WorkspaceQuery");
        },

        _onModelChange: function () {
            // summary:
            //      Updates canExecute after the model has been updated. Subclasses should override this method.
            // tags:
            //      protected
            var sendLink = this;
            var registry = dependency.resolve("epi.storeregistry");
            var store = registry.get("workspace.translationprojectstore");
            dojo.when(store.get(this.model.contentLink + "?" + Math.random() * 9999999999), function (item) {
                
                if (item.unimportedContent) {
                    sendLink.set("canExecute", true);
                } else {
                    sendLink.set("canExecute", false);
                }
            });
        }
    });
})