﻿define([
    "dojo/dom",
    "dojo/dom-construct",
    "dijit/form/Select",
    "dojo/_base/window",
    "dojo/domReady!"
], function (
    dom,
    domConstruct,
    Select,
    win
) {
    window["ecorelioni"] = {

        ko: null,
        _projectId: -1,
        dialog: null,
        nodes: null,
        dataStore: null,
        workspaceStore: null,
        treeViewModel: null,

        init: function (epieditor, dataStore, workspaceStore, ko) {
            var self = this;
                        
            if (!self.dialog)
                self.dialog = new dijit.Dialog({
                    content: dojo.cache("workspace.components.contenttypetree", "contenttypetree.html?v=" + new Date().getTime()),
                    style: 'width: 90%; height: 95%;',
                    title: 'Restrict Translation'
                });

            self.dataStore = dataStore;
            self.workspaceStore = workspaceStore;
            self.ko = ko;

            self.treeViewModel = new TreeViewModel();

            self.bindModel();
        },

        showDialog: function () {
            var self = this;
            indexPage = 0;
            indexBlock = 0;

            self.treeViewModel.reset();
            if (self.treeViewModel.obserNodes() == 0) {
                var query = self.dataStore.get("0?" + Math.random() * 9999999999);
                if (query.then) {
                    query.then(function (item) {
                        for (var i = 0; i < item.result.length; i++) {
                            self.treeViewModel.obserNodes.push(new NodeViewModel(item.result[i]));
                        }
                        $n('.lion-select-not-copy-prop').each(function () {
                            $n(this).on('click', function () {
                                if ($n('#lion-select-all-not-copy-prop')[0].checked)
                                    $n('#lion-select-all-not-copy-prop')[0].indeterminate = true;
                            });
                        })
                    });
                } 
            }
            
            self.dialog.show();
        },

        saveRestrictProps: function () {
            var self = this;
            let ids = [];
            let notCopyIds = [];
            for (let item of self.treeViewModel.obserSelectedNodes())
                ids.push(item.id);
            for (let item of self.treeViewModel.obserSelectedNotCopyNodes())
                notCopyIds.push(item.id);
            self.workspaceStore.put({
                action: 'restrictproperties',
                notTranslateIds: ids,
                notCopyIds: notCopyIds
            }).then(function (item) {
                self.closeDialog();
            }, function (err) {
                self.closeDialog();
            });
        },

        closeDialog: function () {
            this.dialog.hide();
        },

        bindModel: function () {
            this.ko.bindingHandlers.isSelectAllChildrenNode = {
                init: function (element, valueAccessor, allBindings) {
                    //ecorelioni.ko.bindingHandlers.value.init(element, valueAccessor, allBindings);
                },
                update: function (element, valueAccessor, allBindings) {
                    // First get the latest data that we're bound to
                    var value = valueAccessor();

                    // Next, whether or not the supplied model property is observable, get its current value
                    var valueUnwrapped = ecorelioni.ko.unwrap(value);

                    // Now manipulate the DOM element
                    $n(element)[0].checked = valueUnwrapped;
                    //$n(element)[0].indeterminate = valueUnwrapped;
                }
            };
            this.ko.bindingHandlers.setLeftPadding = {
                init: function (element, valueAccessor, allBindings) {
                    //ecorelioni.ko.bindingHandlers.value.init(element, valueAccessor, allBindings);
                },
                update: function (element, valueAccessor, allBindings) {
                    // First get the latest data that we're bound to
                    var value = valueAccessor();

                    // Next, whether or not the supplied model property is observable, get its current value
                    var valueUnwrapped = ecorelioni.ko.unwrap(value);

                    // Now manipulate the DOM element
                    $n(element)[0].style.paddingLeft = valueUnwrapped + 'px';
                }
            };
            this.ko.applyBindings(this.treeViewModel, document.getElementById("lb-editor-content-type"));
        },

        unbindModel: function () {
            var self = this;
            var node = $n("#lb-editor-content-type");
            node.find("*").each(function () {
                $n(this).unbind();
            });

            ko.cleanNode(document.getElementById("lb-editor-content-type"));
        },

    };
});



function TreeViewModel() {
    var self = this;
    var ecorelioni = window["ecorelioni"];
    self.obserNodes = ecorelioni.ko.observableArray([]);
    self.obserSelectedNodes = ecorelioni.ko.observableArray([]);
    self.obserSelectedNotCopyNodes = ecorelioni.ko.observableArray([]);
    self.obserSelectedAllNotCopyNodes = ecorelioni.ko.observable(false);

    self.addSelectedNodes = function (node) {
        for (let n of self.obserSelectedNodes()) {
            if (n.id == node.id) return;
        }
        self.obserSelectedNodes.push(node);
    }

    self.removeSelectedNodes = function (node) {
        for (let n of self.obserSelectedNodes()) {
            if (n.id == node.id) {
                self.obserSelectedNodes.remove(node);
                return;
            }
        }      
    }

    self.addSelectedNotCopyNodes = function (node) {
        for (let n of self.obserSelectedNotCopyNodes()) {
            if (n.id == node.id) return;
        }
        self.obserSelectedNotCopyNodes.push(node);
    }

    self.removeSelectedNotCopyNodes = function (node) {
        for (let n of self.obserSelectedNotCopyNodes()) {
            if (n.id == node.id) {
                self.obserSelectedNotCopyNodes.remove(node);
                return;
            }
        }
    }

    self.obserSelectedAllNotCopyNodes.subscribe(function (value) {
        for (let n of self.obserSelectedNodes()) {
            n.obserIsSelectedNotCopy(value);
        }
    })

    self.reset = function () {
        self.obserNodes([]);
        self.obserSelectedNodes([]);
        self.obserSelectedNotCopyNodes([]);
    }
}

var indexPage = 0;
var indexBlock = 0;

function NodeViewModel(itemData, parent = null, leftPadding = 44) {
    var self = this;
    var ecorelioni = window["ecorelioni"];
    self.parentNode = parent;
    self.name = itemData.name;
    self.location = itemData.location;
    self.id = itemData.id;
    self.type = itemData.type;
    self.contentType = itemData.contentType;
    self.nodes = [];
    self.indexBlockNode = itemData.contentType == 'Block' ? indexBlock++ : 0;// show separate group type
    self.indexPageNode = itemData.contentType == 'Page' ? indexPage++ : 0;// show separate group type
    
    self.obserLeftPadding = ecorelioni.ko.observable(leftPadding);
    self.obserNodes = ecorelioni.ko.observableArray(self.nodes);
    self.obserIsExpandVisible = ecorelioni.ko.observable(itemData.type == 'contenttype' ? true : false);
    self.obserIsChildrenVisible = ecorelioni.ko.observable(itemData.isContainSelected);
    self.obserIsSelected = ecorelioni.ko.observable(itemData.type == 'contenttype' ? itemData.isSelectAllChildrenNode : itemData.isSelected);
    self.obserIsSelectedNotCopy = ecorelioni.ko.observable(itemData.type == 'contenttype' ? false : itemData.isSelectedNotCopy);
    self.obserIsSelectAllChildrenNode = ecorelioni.ko.observable(itemData.type == 'contenttype' ? itemData.isSelectAllChildrenNode : itemData.isSelected);

    self.obserIsSelected.extend({ notify: 'always' });    
    //self.obserIsSelectAllChildrenNode.extend({ notify: 'always' });    

    self.expandChildren = function () {
        self.obserIsChildrenVisible(!self.obserIsChildrenVisible());

        if (!self.obserIsChildrenVisible()) return;

        if (self.obserNodes().length > 0) return;

        var query = ecorelioni.dataStore.get(itemData.id + "?" + Math.random() * 9999999999);
        if (query.then) {
            query.then(function (item) {
                self.addChildrenNode(item.result);
            });
        }
    };

    self.addChildrenNode = function (items) {
        for (var i = 0; i < items.length; i++) {
            if (!self.isExistNode(items[i]))
                self.obserNodes.push(new NodeViewModel(items[i], self));
        }
    };

    self.isExistNode = function (node) {
        for (let existNode of self.obserNodes()) {
            if (existNode.id == node.id) return true;
        }
        return false;
    };

    self.selectAllChildrenNode = function (value) {
        for (let node of self.obserNodes()) {
            node.obserIsSelected(value);
        }
    }

    self.obserIsSelectedNotCopy.subscribe(function (value) {
        //$n('#lion-select-all-copy-prop').indeterminate = true;
        if (value) {
            ecorelioni.treeViewModel.addSelectedNotCopyNodes(self);
        } else {
            ecorelioni.treeViewModel.removeSelectedNotCopyNodes(self);
        }
    })

    self.obserIsSelected.subscribe(function (value) {
        if (value == 'none') return;

        if (itemData.type == 'contenttype' && self.obserNodes().length == 0) {
            var query = ecorelioni.dataStore.get(itemData.id + "?" + Math.random() * 9999999999);
            if (query.then) {
                query.then(function (item) {
                    self.addChildrenNode(item.result);
                    self.selectAllChildrenNode(value);
                });
            }
        } else if (itemData.type == 'contenttype' && self.obserNodes().length > 0) {
            self.selectAllChildrenNode(value);
        }

        if (itemData.type == 'contenttype') return;

        if (value) {
            ecorelioni.treeViewModel.addSelectedNodes(self);
        } else {
            ecorelioni.treeViewModel.removeSelectedNodes(self);
        }

        var isSelectAllChildrenNode = function () {
            if (!self.parentNode) return self.obserIsSelected();
            if (self.parentNode.obserNodes().length == 0) return self.obserIsSelected();
            for (let node of self.parentNode.obserNodes()) {
                if (!node.obserIsSelected())
                    return false;
            }
            return true;
        }
        if (self.parentNode)
            self.parentNode.obserIsSelectAllChildrenNode(isSelectAllChildrenNode());
    });

    self.notSelectThisNode = function () {
        self.obserIsSelected(false);
    };

    function initNodes() {
        if (self.type != 'contenttype')
            self.obserIsSelected(itemData.isSelected);
        if (!itemData.nodes) return;
        for (let node of itemData.nodes) {
            self.obserNodes.push(new NodeViewModel(node, self));
        }
    };
    initNodes();

}