﻿define([
    // Dojo
    "dojo/_base/declare",
    "dojo/on",
    "dojo/request",
    // Dijit
    "dijit/_TemplatedMixin",
    "dijit/_Container",
    "dijit/layout/_LayoutWidget",
    //"dijit/layout/_ContentPane",
    "dijit/_WidgetsInTemplateMixin",
    "epi-cms/_ContentContextMixin",
    "epi/dependency",
    "epi/routes",
    "epi/shell/widget/dialog/Alert",
    "epi/shell/widget/dialog/Confirmation",
    "epi/shell/command/_WidgetCommandProviderMixin",
    //Custom
    "workspace/components/workspacegrid",
    "workspace/commands/addcurrentitem",
    "workspace/commands/clearitems",
    "workspace/commands/settings",   
    "dojo/text!./dashboard.html",
    "dojo/text!./epi-modal.html",
    "dojo/domReady!"
], function (
    // Dojo
    declare,
    on,
    request,
    // Dijit
    _TemplatedMixin,
    _Container,
    _LayoutWidget,
    _WidgetsInTemplateMixin,
    _ContentContextMixin,
    dependency,
    routes,
    Alert,
    Confirmation,
    _WidgetCommandProviderMixin,
    //custom
    WorkspaceGrid,
    AddCurrentItem,
    ClearItems,
    Settings,  
    template,
    epiModal,
) {

    return declare(
        [_Container, _LayoutWidget, _TemplatedMixin, _WidgetsInTemplateMixin, _ContentContextMixin, _WidgetCommandProviderMixin], {
        templateString: template,
        widgetsInTemplate: true,
        store: null,
        context: null,

        contextChanged: function (context, callerData) {
            this.context = context;
            this.inherited(arguments);
        },

        _getRestPath: function (name) {
            return routes.getRestPath({ moduleArea: "lionbridgeconnector", storeName: name }); //moduleArea: 'app' for internal build | lionbridgeconnector for external build
        },
        //_publishNow: function() {
        //    this.store.put('-2');
        //    this._reloadGrid();
        //},
        _store: function () {
            var registry = dependency.resolve("epi.storeregistry");
            if (registry._stores["workspace.workspacestore"] === undefined) {
                registry.create("workspace.workspacestore", this._getRestPath("workspacestore"));
                registry.create("workspace.translationprojectstore", this._getRestPath("translationprojectstore"));
                registry.create("workspace.translationprojecteditorstore", this._getRestPath("translationprojecteditorstore"));
                registry.create("workspace.translationprojecttreestore", this._getRestPath("translationprojecttreestore"));
                registry.create("workspace.translationprojectblocktreestore", this._getRestPath("translationprojectblocktreestore"));
                registry.create("workspace.translationsearchitemsstore", this._getRestPath("translationsearchitemsstore"));
                registry.create("workspace.publishprojectstore", this._getRestPath("publishprojectstore"));
                registry.create("workspace.importprojectstore", this._getRestPath("importprojectstore"));
                registry.create("workspace.settingstore", this._getRestPath("settingstore"));
                registry.create("workspace.archiveprojectstore", this._getRestPath("archiveprojectstore"));
                registry.create("workspace.dashboardstore", this._getRestPath("dashboardstore"));
                registry.create("workspace.publishprojectlanguagestore", this._getRestPath("publishprojectlanguagestore"));
                registry.create("workspace.importprojectlanguagestore", this._getRestPath("importprojectlanguagestore"));
                registry.create("workspace.authenticationstore", this._getRestPath("authenticationstore"));
            }

            if (registry._stores["workspace.lionjobstore"] === undefined) {
                registry.create("workspace.lionjobstore", this._getRestPath("lionjobstore"));
            }
            if (registry._stores["workspace.lioncontentstore"] === undefined) {
                registry.create("workspace.lioncontentstore", this._getRestPath("lioncontentstore"));
            }
            if (registry._stores["workspace.lioncontenttypestore"] === undefined) {
                registry.create("workspace.lioncontenttypestore", this._getRestPath("lioncontenttypestore"));
            }

            if (registry._stores["workspace.lionworkspacesettingstore"] === undefined) {
                registry.create("workspace.lionworkspacesettingstore", this._getRestPath("lionworkspacesettingstore"));
            }

            this.store = this.store || registry.get("workspace.workspacestore");
            return this.store;
        },

        
        startup: function () {
            var self = this;

            self.inherited(arguments);
            this._store();
            LionBridgeConnectorJs.projectServiceUrl = window.location.origin + this._getRestPath("translationprojectliststore");
            LionBridgeConnectorJs.projectTranslationLanguageServiceUrl = window.location.origin + this._getRestPath("projecttranslationlanguageliststore");
            LionBridgeConnectorJs.projectAssetServiceUrl = window.location.origin + this._getRestPath("projectassetliststore");

            //Service functions
            LionBridgeConnectorJs.workspacestoreServiceUrl = window.location.origin + this._getRestPath("workspacestore");
            LionBridgeConnectorJs.translationprojectstoreServiceUrl = window.location.origin + this._getRestPath("translationprojectstore");
            LionBridgeConnectorJs.translationprojecteditorstoreServiceUrl = window.location.origin + this._getRestPath("translationprojecteditorstore");
            LionBridgeConnectorJs.translationprojecttreestoreServiceUrl = window.location.origin + this._getRestPath("translationprojecttreestore");
            LionBridgeConnectorJs.translationprojectblocktreestoreServiceUrl = window.location.origin + this._getRestPath("translationprojectblocktreestore");
            LionBridgeConnectorJs.translationsearchitemsstoreServiceUrl = window.location.origin + this._getRestPath("translationsearchitemsstore");
            LionBridgeConnectorJs.publishprojectstoreServiceUrl = window.location.origin + this._getRestPath("publishprojectstore");
            LionBridgeConnectorJs.importprojectstoreServiceUrl = window.location.origin + this._getRestPath("importprojectstore");
            LionBridgeConnectorJs.publishprojectlanguagestoreServiceUrl = window.location.origin + this._getRestPath("publishprojectlanguagestore");
            LionBridgeConnectorJs.importprojectlanguagestoreServiceUrl = window.location.origin + this._getRestPath("importprojectlanguagestore");
            LionBridgeConnectorJs.settingstoreServiceUrl = window.location.origin + this._getRestPath("settingstore");
            LionBridgeConnectorJs.archiveprojectServiceUrl = window.location.origin + this._getRestPath("archiveprojectstore");

            LionBridgeConnectorJs.lionJobApiUrl = window.location.origin + this._getRestPath("lionjobstore");

            //Object dojo
            LionBridgeConnectorJs.dependency = dependency;
            LionBridgeConnectorJs.Alert = Alert;
            LionBridgeConnectorJs.Confirmation = Confirmation;
            LionBridgeConnectorJs.epiModal = epiModal;
            LionBridgeConnectorJs.dojo = dojo;
            LionBridgeConnectorJs.dojoOn = on;
            LionBridgeConnectorJs.request = request;

            
            LionBridgeConnectorGrid.onRenderGrid();
            LionBridgeConnectorGrid.onRegisterClass();
            LionBridgeConnectorGrid.registerEventDashboard();
        },
        postCreate: function () {
            var registry = dependency.resolve('epi.globalcommandregistry');
            if (registry) {
                var globalToolbar = registry._mappings['epi.cms.globalToolbar'];

                if (globalToolbar && globalToolbar.providers.length > 0) {
                    for (var i = 0; i < globalToolbar.providers.length; i++) {
                        var provider = globalToolbar.providers[i];
                        if (provider.commands.length > 0) {
                            for (var j = 0; j < provider.commands.length; j++) {
                                var command = provider.commands[j];
                                if (command.canExecute === undefined)
                                    break;
                                if (command.category === undefined || command.category !== "compare")
                                    continue;

                                command.canExecute = false;
                            }
                        }
                    }
                }
            }
        },
    });
});


//var $ = jQuery;

var LionBridgeConnectorConstant = LionBridgeConnectorConstant || (function () {
    var archiveText = "Archive";
    var unArchiveText = "Unarchive";
    var archivedText = "Archived";
    var unArchivedText = "Unarchived";
    var viewArchivedJobs = "View Archived Jobs";
    var viewUnarchivedJobs = "View Unarchived Jobs";
    var draft = "Draft";
    var sending = "Sending";
    var inTranslation = "In Translation";
    var readyForImport = "Ready for import";
    var importing = "Importing";
    var imported = "Imported";
    var publishing = "Publishing";
    var published = "Published";
    var cancelled = "Cancelled";
    return {
        archiveText: archiveText,
        unArchiveText: unArchiveText,
        archivedText: archivedText,
        unArchivedText: unArchivedText,
        viewArchivedJobs: viewArchivedJobs,
        viewUnarchivedJobs: viewUnarchivedJobs,
        draft: draft,
        sending: sending,
        inTranslation: inTranslation,
        readyForImport: readyForImport,
        importing: importing,
        imported: imported,
        publishing: publishing,
        published: published,
        cancelled: cancelled,
    }
})();

var LionBridgeConnectorJs = LionBridgeConnectorJs || (function () {

    function onEditProject(id) {
        window.open(id, '_blank');
     }

    function onTranslate(id, item) {
        lionConfirmation = new LionBridgeConnectorJs.Confirmation({
            title: "Confirm Sending",
            description: "Are you sure you want to send?",
            onAction: function (confirmed) {
                if (confirmed) {
                    $n(item).parent().remove();
                    setTimeout(function () {
                        var registry = LionBridgeConnectorJs.dependency.resolve("epi.storeregistry");
                        var store = registry.get("workspace.lionjobstore");
                        store.put({
                            id: id,
                            action: 'send'
                        }).then(function (response) {
                            console.log("sending success");
                            if (response.error) {
                                var errorDialog = new LionBridgeConnectorJs.Alert({
                                    heading: "Job not sent",
                                    description: "Something went wrong when sending the job due to: " + response.errorMessage,
                                    onAction: function () {
                                        if (typeof LionBridgeConnectorGrid !== "undefined") {
                                            LionBridgeConnectorGrid.onReloadGrid();
                                        }
                                        //Refresh gadget also
                                        if (typeof LionBridgeConnectorGadget !== "undefined") {
                                            LionBridgeConnectorGadget.reloadGadget();
                                        }
                                    }
                                });
                                errorDialog.show();
                            } else if ('case did send') {
                                var dialog = new LionBridgeConnectorJs.Alert({
                                    heading: "Job sending",
                                    description:
                                        "The job is sending... The status will update when processing is complete",
                                    onAction: function () {
                                        if (typeof LionBridgeConnectorGrid !== "undefined") {
                                            LionBridgeConnectorGrid.onReloadGrid();
                                        }
                                        //Refresh gadget also
                                        if (typeof LionBridgeConnectorGadget !== "undefined") {
                                            LionBridgeConnectorGadget.reloadGadget();
                                        }
                                    }
                                });

                                dialog.show();
                            } else {
                                if (typeof LionBridgeConnectorGrid !== "undefined") {
                                    LionBridgeConnectorGrid.onReloadGrid();
                                }
                                //Refresh gadget also
                                if (typeof LionBridgeConnectorGadget !== "undefined") {
                                    LionBridgeConnectorGadget.reloadGadget();
                                }
                            }
                        });
                    }, 1);
                }
            }
        });

        lionConfirmation.show();
    }

    function onImport(id, item) {
        var importConfirm = new LionBridgeConnectorJs.Confirmation({
            title: "Import All Available",
            description: "Are you sure you want to import?",
            onAction: function (confirm) {
                if (!confirm) return;
                $n(item).parent().remove();
                var registry = LionBridgeConnectorJs.dependency.resolve("epi.storeregistry");
                var store = registry.get("workspace.lionjobstore");
                store.put({
                    id: id,
                    action: 'import'
                }).then(function (response) {
                    if (response.error) {
                        var errorDialog = new LionBridgeConnectorJs.Alert({
                            heading: "Job not import",
                            description: "Something went wrong when importing the job: " + response.errorMessage,
                            onAction: function () {
                                //reload grid
                                if (typeof LionBridgeConnectorGrid !== "undefined") {
                                    LionBridgeConnectorGrid.onReloadGrid();
                                }
                                //Refresh gadget also
                                if (typeof LionBridgeConnectorGadget !== "undefined") {
                                    LionBridgeConnectorGadget.reloadGadget();
                                }
                            }
                        });
                        errorDialog.show();
                    }
                    else {
                        var dialog = new LionBridgeConnectorJs.Alert({
                            heading: "Importing",
                            description: "The job is being Imported. The status will update when processing is complete.",
                            onAction: function () {
                                //reload grid
                                if (typeof LionBridgeConnectorGrid !== "undefined") {
                                    LionBridgeConnectorGrid.onReloadGrid();
                                }
                                if (typeof LionBridgeConnectorGadget !== "undefined") {
                                    LionBridgeConnectorGadget.reloadGadget();
                                }
                            }
                        });
                        dialog.show();
                    }

                })
            }
        });
        importConfirm.show();
    }

    function onPublish(id, item) {
        var confirmation = new LionBridgeConnectorJs.Confirmation({
            title: "Publish All Available",
            description: "Are you sure you want to publish?",
            onAction: function (confirmed) {
                if (confirmed) {
                    $n(item).parent().remove();
                    var registry = LionBridgeConnectorJs.dependency.resolve("epi.storeregistry");
                    var store = registry.get("workspace.lionjobstore");
                    store.put({
                        id: id,
                        action: 'publish'
                    }).then(function (response) {
                        if (response.error) {
                            var errorDialog = new LionBridgeConnectorJs.Alert({
                                heading: "Job not publish",
                                description: "Something went wrong when publishing: " + response.errorMessage,
                                onAction: function () {
                                    //reload grid
                                    if (typeof LionBridgeConnectorGrid !== "undefined") {
                                        LionBridgeConnectorGrid.onReloadGrid();
                                    }
                                    //Refresh gadget also
                                    if (typeof LionBridgeConnectorGadget !== "undefined") {
                                        LionBridgeConnectorGadget.reloadGadget();
                                    }
                                }
                            });
                            errorDialog.show();
                        }
                        else {
                            var dialog = new LionBridgeConnectorJs.Alert({
                                heading: "Publishing",
                                description: "The job is being Published. The status will update when processing is complete.",
                                onAction: function () {
                                    //reload grid
                                    if (typeof LionBridgeConnectorGrid !== "undefined") {
                                        LionBridgeConnectorGrid.onReloadGrid();
                                    }

                                    //Refresh gadget also
                                    if (typeof LionBridgeConnectorGadget !== "undefined") {
                                        LionBridgeConnectorGadget.reloadGadget();
                                    }
                                }
                            });
                            dialog.show();
                        }

                    });
                }
            }
        });
        confirmation.show();
    }

    function onCancel(id, item) {
        var confirmation = new LionBridgeConnectorJs.Confirmation({
            title: "Cancel job",
            description: "Are you sure you want to cancel the job?",
            onAction: function (confirmed) {
                if (confirmed) {
                    //$n('.loadingDiv').fadeIn(500);
                    $n(item).parent().remove();

                    var registry = LionBridgeConnectorJs.dependency.resolve("epi.storeregistry");
                    var store = registry.get("workspace.translationprojectstore");
                    id = id + ";" + "cancel";
                    store.put(id).then(function (item) {
                        if (item !== undefined && item.error) {

                            var dialog = new LionBridgeConnectorJs.Alert({
                                heading: "Cancellation",
                                description: item.errorMessage,
                                onAction: function () {
                                    //reload grid
                                    if (typeof LionBridgeConnectorGrid !== "undefined") {
                                        LionBridgeConnectorGrid.onReloadGrid();
                                    }
                                    //Refresh gadget also
                                    if (typeof LionBridgeConnectorGadget !== "undefined") {
                                        LionBridgeConnectorGadget.reloadGadget();
                                    }
                                }
                            });
                            dialog.show();
                        } else {
                            var dialog = new LionBridgeConnectorJs.Alert({
                                heading: "Cancelled",
                                description: "Please note that cancelling this project will not cause translation work to stop. Please contact Lionbridge to ensure that your work is stopped.",
                                onAction: function () {
                                    //reload grid
                                    if (typeof LionBridgeConnectorGrid !== "undefined") {
                                        LionBridgeConnectorGrid.onReloadGrid();
                                    }
                                    //Refresh gadget also
                                    if (typeof LionBridgeConnectorGadget !== "undefined") {
                                        LionBridgeConnectorGadget.reloadGadget();
                                    }
                                }
                            });
                            dialog.show();
                        }
                        //$n('.loadingDiv').fadeOut(500);
                    });
                }
            }
        });
        confirmation.show();
    }

    function onRemove(id, item) {
        var confirmation = new LionBridgeConnectorJs.Confirmation({
            title: "Remove job",
            description: "Are you sure you want to remove the job?",
            onAction: function (confirmed) {
                if (confirmed) {

                    //$n('.loadingDiv').fadeIn(500);
                    $n(item).parent().remove();

                    var registry = LionBridgeConnectorJs.dependency.resolve("epi.storeregistry");
                    var store = registry.get("workspace.workspacestore");

                    store.remove(id).then(function (item) {
                        //reload grid
                        if (item !== undefined && item.error) {
                            var errorDialog = new Alert({
                                heading: "Remove Job",
                                description: "Something went wrong when removing the job due to: " + item.errorMessage,
                                onAction: function () {
                                    //reload grid
                                    if (typeof LionBridgeConnectorGrid !== "undefined") {
                                        LionBridgeConnectorGrid.onReloadGrid();
                                    }
                                    //Refresh gadget also
                                    if (typeof LionBridgeConnectorGadget !== "undefined") {
                                        LionBridgeConnectorGadget.reloadGadget();
                                    }
                                }
                            });
                            errorDialog.show();
                        } else {
                            var dialog = new LionBridgeConnectorJs.Alert({
                                heading: "Removed",
                                description: "The Translation Job is being Removed.",
                                onAction: function () {
                                    if (typeof LionBridgeConnectorGrid !== "undefined") {
                                        LionBridgeConnectorGrid.onReloadGrid();
                                    }
                                    //Refresh gadget also
                                    if (typeof LionBridgeConnectorGadget !== "undefined") {
                                        LionBridgeConnectorGadget.reloadGadget();
                                    }

                                    $n('#niteco-archive-all-button').attr('disabled', true);
                                    $n('#niteco-delete-all-button').attr('disabled', true);
                                    var rows = LionBridgeConnectorGrid.projectTable.rows({ 'search': 'applied' }).nodes();
                                    let items = $n('input[type="checkbox"]', rows);
                                    for (let i = 0; i < items.length; i++) {
                                        if ($n(items[i]).get(0).checked === true && $n(items[i]).attr('jobId') != id) {
                                            if ($n(items[i]).attr('job-status') != LionBridgeConnectorConstant.inTranslation &&
                                                $n(items[i]).attr('job-status') != LionBridgeConnectorConstant.readyForImport) {
                                                $n('#niteco-delete-all-button').attr('disabled', false);
                                            }
                                            if ($n(items[i]).attr('job-status') != LionBridgeConnectorConstant.draft &&
                                                $n(items[i]).attr('job-status') != LionBridgeConnectorConstant.sending) {
                                                $n('#niteco-archive-all-button').attr('disabled', false);
                                            }
                                        }
                                    }
                                    LionBridgeConnectorGrid.listSelectJobs = LionBridgeConnectorGrid.listSelectJobs.filter((item) => item.Id != id);
                                }
                            });              
                            dialog.show();
                        }
                        //$n('.loadingDiv').fadeOut(500);
                    });

                }
            }
        });
        confirmation.show();

    }

    function onClone(id, item) {
        LionBridgeConnectorJs.dojo.body().insertAdjacentHTML("beforeEnd", LionBridgeConnectorJs.epiModal);
        let modal = LionBridgeConnectorJs.dojo.byId('niteco-epi-modal');
        let hiddenLayout = LionBridgeConnectorJs.dojo.byId('niteco-epi-hidden-layout');
        let nameField = LionBridgeConnectorJs.dojo.byId('niteco-epi-name-field');
        let okBtn = LionBridgeConnectorJs.dojo.byId('niteco-epi-ok-button');
        let cancelBtn = LionBridgeConnectorJs.dojo.byId('niteco-epi-cancel-button');
        let result = 'clone' + id;

        let registry = LionBridgeConnectorJs.dependency.resolve("epi.storeregistry");
        let store = registry.get("workspace.lionjobstore");

        let hideAll = function () {           
            LionBridgeConnectorJs.dojo.destroy('niteco-epi-modal');
            LionBridgeConnectorJs.dojo.destroy('niteco-epi-hidden-layout');
        }

        LionBridgeConnectorJs.dojoOn(okBtn, 'click', function (evt) {
            let proName = nameField.value;
            hideAll();
            //$n('.loadingDiv').fadeIn(500);
            store.put({
                action: "clone",
                id: id,
                jobName: proName
            }).then(function (item) {
                //$n('.loadingDiv').fadeIn(500);                
                if (typeof LionBridgeConnectorGrid !== "undefined") {
                    LionBridgeConnectorGrid.onReloadGrid();
                }

                //Refresh gadget also
                if (typeof LionBridgeConnectorGadget !== "undefined") {
                    LionBridgeConnectorGadget.reloadGadget();
                }

                if (item !== undefined && item.itemLink !== undefined && item.itemLink !== '') {

                    window.open(item.itemLink, '_blank');
                }
                //$n('.loadingDiv').fadeOut(500);
            });
        });

        LionBridgeConnectorJs.dojoOn(cancelBtn, 'click', function (evt) {
            hideAll();
        });
    }


    function archiveAllJob() {       
        var confirmation = new LionBridgeConnectorJs.Confirmation({
            title: 'Archive',
            description: "Are you sure you want to archive the selected jobs?",
            onAction: function (confirmed) {
                if (confirmed) {
                    //$n('.loadingDiv').fadeIn(500);
                    //$n(item).parent().remove();
                    var registry = LionBridgeConnectorJs.dependency.resolve("epi.storeregistry");
                    var store = registry.get("workspace.archiveprojectstore");
                    var data = JSON.stringify({ IsMulti: 'true', Archives: LionBridgeConnectorGrid.listSelectJobs });
                    store.put(data).then(function (result) {
                        if (result.error) {
                            var errorDialog = new LionBridgeConnectorJs.Alert({
                                heading: 'Archive all',
                                description: "Something went wrong when " + 'archive the selected jobs' + ": " + result.errorMessage
                            });
                            errorDialog.show();
                        } else {
                            while (LionBridgeConnectorGrid.listSelectJobs.length > 0) {
                                LionBridgeConnectorGrid.listSelectJobs.pop();
                            }
                            $n('#niteco-archive-all-button').attr('disabled', true);
                            //$n('#niteco-delete-all-button').attr('disabled', false);
                            //reload grid
                            //LionBridgeConnectorGrid.onReloadGrid();
                            if (typeof LionBridgeConnectorGrid !== "undefined") {
                                LionBridgeConnectorGrid.onReloadGrid();
                            }

                            //Refresh gadget also
                            if (typeof LionBridgeConnectorGadget !== "undefined") {
                                LionBridgeConnectorGadget.reloadGadget();
                            }
                            
                        }
                        //$n('.loadingDiv').fadeOut(500);
                    });
                }
            }
        });
        confirmation.show();

    }

    function removeAllJob() {
        var confirmation = new LionBridgeConnectorJs.Confirmation({
            title: "Remove",
            description: "Are you sure you want to remove the selected jobs?",
            onAction: function (confirmed) {
                if (confirmed) {
                    //$n('.loadingDiv').fadeIn(500);
                    //$n(item).parent().remove();
                    var registry = LionBridgeConnectorJs.dependency.resolve("epi.storeregistry");
                    var store = registry.get("workspace.workspacestore");
                    var data = JSON.stringify({ isMulti: 'true', jobs: LionBridgeConnectorGrid.listSelectJobs, action: 'deleteall' });
                    store.put(data).then(function (item) {
                        //reload grid
                        if (item !== undefined && item.error) {
                            var errorDialog = new Alert({
                                heading: "Remove Job",
                                description: "Something went wrong when removing the selected jobs due to: " + item.errorMessage,
                                onAction: function () {
                                    //reload grid
                                    if (typeof LionBridgeConnectorGrid !== "undefined") {
                                        LionBridgeConnectorGrid.onReloadGrid();
                                    }
                                    //Refresh gadget also
                                    if (typeof LionBridgeConnectorGadget !== "undefined") {
                                        LionBridgeConnectorGadget.reloadGadget();
                                    }
                                }
                            });
                            errorDialog.show();
                        } else {
                            while (LionBridgeConnectorGrid.listSelectJobs.length > 0) {
                                LionBridgeConnectorGrid.listSelectJobs.pop();
                            }
                            //$n('#niteco-archive-all-button').attr('disabled', false);
                            $n('#niteco-delete-all-button').attr('disabled', true);
                            //reload grid
                            if (typeof LionBridgeConnectorGrid !== "undefined") {
                                LionBridgeConnectorGrid.onReloadGrid();
                            }
                            //Refresh gadget also
                            if (typeof LionBridgeConnectorGadget !== "undefined") {
                                LionBridgeConnectorGadget.reloadGadget();
                            }
                        }
                        //$n('.loadingDiv').fadeOut(500);
                    });
                }
            }
        });
        confirmation.show();
    }

    function onImportByLanguage(id, language, item) {
        var confirmation = new LionBridgeConnectorJs.Confirmation({
            title: "Import",
            description: "Are you sure you want to import?",
            onAction: function (confirmed) {
                if (confirmed) {
                    var registry = LionBridgeConnectorJs.dependency.resolve("epi.storeregistry");
                    var store = registry.get("workspace.lionjobstore");
                    store.put({
                        id: id,
                        action: 'import',
                        language: language
                    }).then(function (result) {
                        if (result.error) {
                            var errorDialog = new LionBridgeConnectorJs.Alert({
                                heading: "Import",
                                description: "Something went wrong when importing the job: " + result.errorMessage
                            });
                            errorDialog.show();
                        }
                        else {
                            var dialog = new LionBridgeConnectorJs.Alert({
                                heading: "Importing",
                                description: "The selected Job languages are being Imported. The status will update when processing is complete.",
                                onAction: function () {
                                    
                                    if (typeof LionBridgeConnectorGrid !== "undefined") {
                                        LionBridgeConnectorGrid.onReloadGrid();
                                    }

                                    //Refresh gadget also
                                    if (typeof LionBridgeConnectorGadget !== "undefined") {
                                        LionBridgeConnectorGadget.reloadGadget();
                                    }
                                }
                            });
                            dialog.show();
                        }

                    });
                }
            }
        });
        confirmation.show();
    }

    function onPublishByLanguage(id, language, item) {
        var confirmation = new LionBridgeConnectorJs.Confirmation({
            title: "Publish",
            description: "Are you sure you want to publish?",
            onAction: function (confirmed) {
                if (confirmed) {
                    var registry = LionBridgeConnectorJs.dependency.resolve("epi.storeregistry");
                    var store = registry.get("workspace.lionjobstore");
                    store.put({
                        id: id,
                        action: 'publish',
                        language: language
                    }).then(function (result) {
                        if (result.error) {
                            var errorDialog = new LionBridgeConnectorJs.Alert({
                                heading: "Publish",
                                description: "Something went wrong when publishing: " + result.errorMessage
                            });
                            errorDialog.show();
                        } else {
                            var dialog = new LionBridgeConnectorJs.Alert({
                                heading: "Publishing",
                                description: "The selected Job languages are being Published. The status will update when processing is complete.",
                                onAction: function () {
                                   
                                    if (typeof LionBridgeConnectorGrid !== "undefined") {
                                        LionBridgeConnectorGrid.onReloadGrid();
                                    }

                                    //Refresh gadget also
                                    if (typeof LionBridgeConnectorGadget !== "undefined") {
                                        LionBridgeConnectorGadget.reloadGadget();
                                    }
                                }
                            });
                            dialog.show();


                        }

                    });
                }
            }
        });
        confirmation.show();
    }

    function onArchive(id, archive, item) {
        var title = archive === true ? LionBridgeConnectorConstant.archiveText : LionBridgeConnectorConstant.unArchiveText;
        var heading = archive === true ? LionBridgeConnectorConstant.archivedText : LionBridgeConnectorConstant.unArchivedText;
        var confirmation = new LionBridgeConnectorJs.Confirmation({
            title: title,
            description: "Are you sure you want to " + title.toLowerCase() + " the job?",
            onAction: function (confirmed) {
                if (confirmed) {
                    //$n('.loadingDiv').fadeIn(500);
                    var registry = LionBridgeConnectorJs.dependency.resolve("epi.storeregistry");
                    var store = registry.get("workspace.archiveprojectstore");
                    var data = JSON.stringify({ id: id, archive: archive });
                    store.put(data).then(function (result) {
                        if (result.error) {
                            var errorDialog = new LionBridgeConnectorJs.Alert({
                                heading: title,
                                description: "Something went wrong when " + title.toLowerCase() + ": " + result.errorMessage
                            });
                            errorDialog.show();
                        } else {
                            var dialog = new LionBridgeConnectorJs.Alert({
                                heading: heading,
                                description: "The job is being " + heading.toLowerCase() + ".",
                                onAction: function () {
                                    //reload grid
                                    //LionBridgeConnectorGrid.onReloadGrid();
                                    if (typeof LionBridgeConnectorGrid !== "undefined") {
                                        LionBridgeConnectorGrid.refreshChildGrid(item);
                                    }

                                    //Refresh gadget also
                                    if (typeof LionBridgeConnectorGadget !== "undefined") {
                                        LionBridgeConnectorGadget.reloadGadget();
                                    }

                                    $n('#niteco-archive-all-button').attr('disabled', true);
                                    $n('#niteco-delete-all-button').attr('disabled', true);
                                    var rows = LionBridgeConnectorGrid.projectTable.rows({ 'search': 'applied' }).nodes();
                                    let items = $n('input[type="checkbox"]', rows);
                                    for (let i = 0; i < items.length; i++) {
                                        if ($n(items[i]).get(0).checked === true && $n(items[i]).attr('jobId') != id) {
                                            if ($n(items[i]).attr('job-status') != LionBridgeConnectorConstant.inTranslation &&
                                                $n(items[i]).attr('job-status') != LionBridgeConnectorConstant.readyForImport) {
                                                $n('#niteco-delete-all-button').attr('disabled', false);
                                            }
                                            if ($n(items[i]).attr('job-status') != LionBridgeConnectorConstant.draft &&
                                                $n(items[i]).attr('job-status') != LionBridgeConnectorConstant.sending) {
                                                $n('#niteco-archive-all-button').attr('disabled', false);
                                            }
                                        }
                                    }
                                    LionBridgeConnectorGrid.listSelectJobs = LionBridgeConnectorGrid.listSelectJobs.filter((item) => item.Id != id);

                                }
                            });
                            dialog.show();
                        }
                        //$n('.loadingDiv').fadeOut(500);
                    });
                }
            }
        });
        confirmation.show();
    }

    function onGetArchiving() {
        //1-Archiving //0-UnArchiving
        var value = window.localStorage.getItem(archivingName);
        if (value === undefined || value === null || value === '')
            return "false";

        return value;
    }

    function onSetArchiving(value) {
        //1-Archiving //2-UnArchiving
        window.localStorage.setItem(archivingName, value);
    }

    var archivingName = 'lionbridge-archiving';
    //Service
    var projectServiceUrl;
    var projectTranslationLanguageServiceUrl;
    var projectAssetServiceUrl;
    var workspacestoreServiceUrl;
    var translationprojectstoreServiceUrl;
    var translationprojecteditorstoreServiceUrl;
    var translationprojecttreestoreServiceUrl;
    var translationprojectblocktreestoreServiceUrl;
    var translationsearchitemsstoreServiceUrl;
    var publishprojectstoreServiceUrl;
    var importprojectstoreServiceUrl;
    var publishprojectlanguagestoreServiceUrl;
    var importprojectlanguagestoreServiceUrl;
    var settingstoreServiceUrl;
    var dependency;
    var Alert;
    var Confirmation;
    var archiveprojectServiceUrl;

    return {
        onTranslate: onTranslate,
        onImport: onImport,
        onPublish: onPublish,
        onCancel: onCancel,
        onRemove: onRemove,
        onClone: onClone,
        archiveAllJob: archiveAllJob,
        removeAllJob: removeAllJob,
        onEditProject: onEditProject,
        onImportByLanguage: onImportByLanguage,
        onPublishByLanguage: onPublishByLanguage,
        //Service
        projectServiceUrl: projectServiceUrl,
        projectTranslationLanguageServiceUrl: projectTranslationLanguageServiceUrl,
        projectAssetServiceUrl: projectAssetServiceUrl,

        workspacestoreServiceUrl: workspacestoreServiceUrl,
        translationprojectstoreServiceUrl: translationprojectstoreServiceUrl,
        translationprojecteditorstoreServiceUrl: translationprojecteditorstoreServiceUrl,
        translationprojecttreestoreServiceUrl: translationprojecttreestoreServiceUrl,
        translationprojectblocktreestoreServiceUrl: translationprojectblocktreestoreServiceUrl,
        translationsearchitemsstoreServiceUrl: translationsearchitemsstoreServiceUrl,
        publishprojectstoreServiceUrl: publishprojectstoreServiceUrl,
        importprojectstoreServiceUrl: importprojectstoreServiceUrl,
        publishprojectlanguagestoreServiceUrl: publishprojectlanguagestoreServiceUrl,
        importprojectlanguagestoreServiceUrl: importprojectlanguagestoreServiceUrl,
        settingstoreServiceUrl: settingstoreServiceUrl,
        archiveprojectServiceUrl: archiveprojectServiceUrl,
        dependency: dependency,
        Alert: Alert,
        Confirmation: Confirmation,
        onGetArchiving: onGetArchiving,
        onSetArchiving: onSetArchiving,
        onArchive: onArchive,
    }
})();

var LionBridgeConnectorGrid = LionBridgeConnectorGrid || (function () {
    var pageSize = 20;
    var projectTable;
    var assetsListTable = {};
    var listSelectJobs = [];

    function onRenderGrid() {
        //$n('#WorkspaceGrid').DataTable({
        //    orderCellsTop: true,
        //    fixedHeader: true
        //});
        var archivingValue = LionBridgeConnectorJs.onGetArchiving();

        var projectColumnSize = [];
        projectColumnSize["Job ID"] = "50px";
        projectColumnSize["Job Name"] = "300px";
        projectColumnSize["Status"] = "100px";
        projectColumnSize["Actions"] = "150px";
        projectColumnSize["Freeway ID"] = "100px";
        projectColumnSize["Languages"] = "80px";
        projectColumnSize["Total Assets"] = "50px";
        projectColumnSize["Creator"] = "100px";
        projectColumnSize["Created"] = "100px";
        projectColumnSize["Due Date"] = "100px";
        projectColumnSize["Delivery Available"] = "100px";

        //define project table  : Project > Asset > Type
        //fix duplicate header incase grid exists.
        if ($n('#project5b83a1a738dc42f4b697404c2d324450 thead tr').length > 1) {
            $n('#project5b83a1a738dc42f4b697404c2d324450 thead tr').each(function (index) {
                if (index > 0) {
                    $n(this).remove();
                }
            });
        }

        var archiving = LionBridgeConnectorJs.onGetArchiving() === "true";

        var archiveButton = document.getElementById('archive6bb3b40543354773812682476d110c8f');

        if (archiveButton) {
            if (archiving) {
                archiveButton.innerHTML = LionBridgeConnectorConstant.viewUnarchivedJobs;
            } else {
                archiveButton.innerHTML = LionBridgeConnectorConstant.viewArchivedJobs;
            }
        }

        $n('#project5b83a1a738dc42f4b697404c2d324450 thead tr')
            .clone(true)
            .addClass('filters')
            .appendTo('#project5b83a1a738dc42f4b697404c2d324450 thead');

        $n('#project5b83a1a738dc42f4b697404c2d324450 thead tr.filters')[0].hidden = true;
        
        LionBridgeConnectorGrid.projectTable = $n('#project5b83a1a738dc42f4b697404c2d324450').DataTable({
            //"fixedHeader": true,
            "processing": true,
            'language': {
                "loadingRecords": "&nbsp;",
                "processing": "Loading..."
            },
            "lengthChange": false,
            "orderCellsTop": true,
            "pageLength": pageSize,
            "autoWidth": false,
            "initComplete": function () {
                $n('#project5b83a1a738dc42f4b697404c2d324450 thead tr.filters')[0].hidden = false;
                var api = this.api();
                api.columns()
                    .eq(0)
                    .each(function (colIdx) {
                        if (colIdx == 0)
                            return;
                        var cell = $n('.filters th').eq(
                            $n(api.column(colIdx).header()).index()
                        );
                        var title = $n(cell).text();
                        switch (colIdx) {
                            case 1:
                                $n(cell).html('<input type="text" style="display: none" placeholder="' + title + '" />');
                                break;
                            case 2:
                                $n(cell).html('<input type="text" style="width: 90%" placeholder="' + title + '" />');
                                break;
                            case 3:
                                $n(cell).html('<input type="text" style="width: 90%" placeholder="' + title + '" />');
                                break;
                            case 4:
                                $n(cell).html('<input type="text" style="width: 90%" placeholder="' + title + '" />');
                                break;
                            case 5:
                                $n(cell).html('<input type="text" style="display: none" placeholder="' + title + '" />');
                                break;
                            case 6:
                                $n(cell).html('<input type="text" style="width: 90%" placeholder="' + title + '" />');
                                break;
                            case 7:
                                $n(cell).html('<input type="text" style="width: 90%" placeholder="' + title + '" />');
                                break;
                            case 8:
                                $n(cell).html('<input type="text" style="width: 90%" placeholder="' + title + '" />');
                                break;
                            case 9:
                                $n(cell).html('<input type="text" style="width: 90%" placeholder="' + title + '" />');
                                break;
                            case 10:
                            case 11:
                                $n(cell).html('<input type="text" style="width: 90%" placeholder="' + title + '" />');
                                break;
                            case 12:
                                $n(cell).html('<input type="text" style="width: 90%" placeholder="' + title + '" />');
                                break;
                            default:
                                $n(cell).html('<input type="text" placeholder="' + title + '" />');
                        }
                        // On every keypress in this input
                        $n(
                            'input',
                            $n('.filters th').eq($n(api.column(colIdx).header()).index())
                        )
                            .off('keyup change')
                            .on('change', function (e) {
                                // Get the search value
                                $n(this).attr('title', $n(this).val());
                                var regexr = '({search})'; //$n(this).parents('th').find('select').val();

                                var cursorPosition = this.selectionStart;
                                // Search the column for that value
                                api
                                    .column(colIdx)
                                    .search(
                                        this.value != ''
                                            ? regexr.replace('({search})', this.value)
                                            : '',
                                        this.value != '',
                                        this.value == ''
                                    )
                                    .draw();
                            })
                            .on('keyup', function (e) {
                                e.stopPropagation();

                                $n(this).trigger('change');
                                $n(this)
                                    .focus()[0]
                                    .setSelectionRange(cursorPosition, cursorPosition);
                            });
                    });
            },
            "ajax": {
                "url": LionBridgeConnectorJs.projectServiceUrl + archivingValue,
                "type": "POST"
            },
            "columns": [
                {
                    "className": 'detail-project',
                    "data": null,
                    "defaultContent": '',
                },
                {
                    "className": '' ,
                    "data": null,
                },
                {
                    "data": "globalTrackingId",
                    "className": "globaltrackingid",
                },
                {
                    "data": "projectName",
                    "className": "projectname",
                },
                {
                    "data": "status",
                    "className": "status",
                },
                {
                    "data": "actions",
                    "className": "action",
                },
                {
                    "data": "freewayID",
                    "className": "freewayid",
                },
                {
                    "data": "languages",
                    "className": "language",
                },
                {
                    "data": "assets",
                    "className": "asset",
                },
                {
                    "data": "creator",
                    "className": "creator",
                },
                {
                    "data": {
                        _: "created.display",
                        sort: "created.timestamp"
                    }
                    ,
                    "className": "created",
                },
                {
                    "data": {
                        _: "deadline.display",
                        sort: "deadline.timestamp",
                    }
                    ,
                    "className": "deadline",
                },
                {
                    "data": "deliveryAvailable",
                    "render": function (data, type, row) {
                        return ((data === true) ? 'Yes' : 'No') + (row.assetLogs !== '' && row.status != "Published" ? " <span class='dijitInline dijitIcon epi-iconWarning ' style='color: orange; font-weight: bold;' title='" + row.assetLogs + "'></span>" : "");
                    }
                    ,
                    "className": "delivery",
                },
            ],
            "columnDefs": [
                {
                    "targets": [0],
                    "orderable": false,
                    "width": "2%"
                },
                {
                    "targets": [1],
                    "orderable": false,
                    "searchable": false,
                    "render": project_job_cell_checkbox_render,
                    "width": "2%"
                },
                {
                    "targets": [2],
                    "render": project_cell_globaltrackingid_render,
                    "width": "auto"
                },
                {
                    "targets": [3],
                    "render": project_cell_name_render,
                    "width": "15%"
                },
                {
                    "targets": [4],
                    "render": project_cell_status_render,
                    "width": "auto"
                },
                {
                    "targets": [5],
                    "render": project_cell_action_render,
                    "orderable": false,
                    "searchable": false,
                    "width": "auto"
                },
                {
                    "targets": [6],
                    "render": project_cell_freewayid_render,
                    "width": "auto"
                },
                {
                    "targets": [7],
                    "type": "num",
                    "width": "6%"
                },
                {
                    "targets": [8],
                    "type": "num",
                    "width": "6%"
                },
                {
                    "targets": [9],
                    "width": "10%"
                },
                {
                    "targets": [10],
                    "width": "7%"
                },
                {
                    "targets": [11],
                    "render": project_cell_deadline_render,
                    "width": "7%"
                }
            ],
            "order": [[10, "desc"]],
            'createdRow': function (row, data, dataIndex) {
                $n(row)
                    .attr('project-id', data.id)
                    .attr('project-percentage-completed', data.percentageCompleted);
                $n('input[type="checkbox"]', row).attr("jobId", data.id);
                $n('input[type="checkbox"]', row).attr("isArchive", data.archive);
                $n('input[type="checkbox"]', row).attr("job-status", data.status);
            },
            "rowCallback": function (row, data, index) {
                //var allData = this.api().column(10).data().toArray();
                //$n('td:eq(10)', row).css('text-align', 'center');
                for (let el of $n('td:eq(5)', row).find('button')) {
                    $n(el).css({ 'background-color': '#e7e7e7', 'border-color': '#c4c4c4'});
                }
            }
        });

        $n('div.dataTables_filter').hide();

        function project_job_cell_checkbox_render(data, type, row, meta) {
            return '<input type="checkbox" />';
        }

        function project_cell_globaltrackingid_render(data, type, row, meta) {

            //if (row.IsSending == true && row.TranslationServiceStatus == null) {
            //    return "<i>Sending...</i>";
            //}
            return row.globalTrackingId;
        };

        function project_cell_action_render(data, type, row, meta) {
            var actions = row.allowActions;
            var buttonGroup = '<div class="btn-group">';

            if (actions && actions != null) {

                for (var i = 0; i < actions.length; i++) {
                    var action = actions[i];

                    if (action == 0) {
                        buttonGroup += '<button type = "button" class="btn btn-danger" onclick="LionBridgeConnectorJs.onEditProject(\'' + row.itemLink + '\')">Edit Job</button>';
                    }
                    if (action == 1) {
                        buttonGroup += '<button type = "button" class="btn btn-danger" onclick="LionBridgeConnectorJs.onEditProject(\'' + row.itemLink + '\')">View Job</button>';
                    }
                }

                buttonGroup +=
                    '<button type="button" class="btn dropdown-toggle" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">' +
                    '<span class="caret"></span>' +
                    '<span class="sr-only">Toggle Dropdown</span>' +
                    '</button>';
                buttonGroup += '<ul class="dropdown-menu">';
                var isDisplayImport = false;
                var isDisplayPublish = false;

                for (var i = 0; i < actions.length; i++) {
                    var action = actions[i];

                    if (action == 0) {
                        buttonGroup += '<li onclick="LionBridgeConnectorJs.onEditProject(\'' + row.itemLink + '\')"><span>Edit Job</span></li>';
                    }
                    if (action == 1) {
                        buttonGroup += '<li onclick="LionBridgeConnectorJs.onEditProject(\'' + row.itemLink + '\')"><span>View Job</span></li>';
                    }
                    if (action == 2) {
                        buttonGroup += '<li onclick="LionBridgeConnectorJs.onTranslate(' + row.id + ', this)"><span>Send to Translation</span></li>';
                    }
                    if ((action == 3 || row.canImport) && !isDisplayImport) {
                        buttonGroup += '<li onclick="LionBridgeConnectorJs.onImport(' + row.id + ', this)"><span>Import All Available</span></li>';
                        isDisplayImport = true;
                    }
                    if ((action == 4 || row.canPublish) && !isDisplayPublish) {
                        buttonGroup += '<li onclick="LionBridgeConnectorJs.onPublish(' + row.id + ', this)"><span>Publish All Available</span></li>';
                        isDisplayPublish = true;
                    }
                    if (action == 5) {
                        if (row.archive) {
                            buttonGroup += '<li onclick="LionBridgeConnectorJs.onArchive(' + row.id + ', false, this)"><span>Unarchive Job</span></li>';
                        } else {
                            buttonGroup += '<li onclick="LionBridgeConnectorJs.onArchive(' + row.id + ', true, this)"><span>Archive Job</span></li>';
                        }
                    }
                    if (action == 6) {
                        buttonGroup += '<li onclick="LionBridgeConnectorJs.onCancel(' + row.id + ', this)"><span>Cancel Job</span></li>';
                    }

                    if (action == 7) {
                        buttonGroup += '<li onclick="LionBridgeConnectorJs.onRemove(' + row.id + ', this)"><span>Remove Job</span></li>';
                    }
                    if (action == 8) {
                        buttonGroup += '<li onclick="LionBridgeConnectorJs.onClone(' + row.id + ', this)"><span>Clone Job</span></li>';
                    }
                }
                buttonGroup += '</ul>';

            }

            buttonGroup += '</div >';            

            return buttonGroup;
        };

        function project_cell_deadline_render(data, type, row, meta) {
            return row.deadline.display + (row.overDue ? " <span class='dijitInline dijitIcon epi-iconWarning' style='color: orange; font-weight: bold;' title='The Requested Due Date has passed'></span>" : "");
        };

        function project_cell_status_render(data, type, row, meta) {

            return row.hasSameStatusAtLanguageLevel ? row.status : "<i>" + row.status + "</i>";
        };

        function project_cell_name_render(data, type, row, meta) {
            return '<a href="javascript:void(0);">' + row.projectName + '</a>' + (row.error ? " <span class='dijitInline dijitIcon epi-iconError' title='" + row.errorMessage + "'></span>" : "");
        };

        function project_cell_freewayid_render(data, type, row, meta) {
            if (row.freewayID === undefined || row.freewayID === '')
                return '';

            var freewayIds = row.freewayID.split(",");
            var links = "";
            for (var i = 0; i < freewayIds.length; i++) {
                var freewayId = freewayIds[i];
                links += '<a href="' + row.freewayLink + freewayId.replace("BV-", "") + '" rel="nofollow" target="_blank">' + freewayId + '</a></br>';
            }

            return links;
        };

        //end project
        //Assets: asset is child's project  : Project > Asset > Type
        //This varial datable child's row

        $n('#project5b83a1a738dc42f4b697404c2d324450 tbody').on('click', 'td.projectname, td.detail-project', function () {
            var tr = $n(this).closest('tr');
            var row = LionBridgeConnectorGrid.projectTable.row(tr);

            //alert('project click', row.data().Id);

            if (row.child.isShown()) {
                // This row is already open - close it
                destroyTransitionProjectLanguage(row);
                tr.removeClass('shown');
            }
            else {
                // Open this row
                createTransitionProjectLanguage(row, 'child-table'); // class is for background colour
                tr.addClass('shown');
            }
        });

        function destroyTransitionProjectLanguage(row) {
            var table = $n("table", row.child());

            //destroy
            table.detach();
            table.DataTable().destroy();

            // And then hide the row
            row.child.hide();
        }

        function createTransitionProjectLanguage(row) {
            var rowMain = row;
            var rowid = row.data().id;
            // This is the table we'll convert into a DataTable
            var table = $n('<table style="width:95%; height: 100%; overflow: auto;" class="second-level"/>');
            var tableTemplate = $n('#pjlanguage7341e559090c45f6a92e15552e27beb3');
            table.html(tableTemplate.html());

            // Display it the child row
            row.child(table).show();

            // Initialise as a DataTable
            var assetsTable = table.DataTable({
                "orderCellsTop": true,
                //"fixedHeader": true,
                "searching": false,
                "lengthChange": false,
                "autoWidth": false,
                "paging": false,
                "info": false,
                "ajax": {
                    "url": LionBridgeConnectorJs.projectTranslationLanguageServiceUrl + rowid,
                },
                "columns": [
                    {
                        "className": 'detail-project-language',
                        "data": null,
                        "defaultContent": ''
                    },
                    { "data": "assets", "className": "project-language", "display": "Assets" },
                    { "data": "sourceLanguages", "className": "sourcelanguage" },
                    { "data": "targetLanguages", "className": "targetlanguage" },
                    { "data": "status", "className": "status" },
                    { "data": "actions" },
                    { "data": "assetUrl" },
                ],
                "columnDefs": [
                    {
                        "targets": [0],
                        "orderable": false,
                    },
                    {
                        "targets": [1],
                        "render": asset_cell_name_render,
                        "width": '10%',
                    },
                    {
                        "targets": [2],
                        "width": '15%',
                    },
                    {
                        "targets": [3],
                        "width": '15%',
                    },
                    {
                        "targets": [4],
                        "width": '10%',
                    },
                    {
                        "targets": [5],
                        "render": asset_cell_action_render,
                        "orderable": false,
                        "width": '10%',
                    },
                    {
                        "targets": [6],
                        "render": project_cell_asset_log_link_render,
                        "orderable": false,
                    }
                ],
                "order": [[1, "desc"]],
                'createdRow': function (row, data, dataIndex) {
                    $n(row).attr('project-id', rowid);
                },
                "fnInitComplete": function (oSettings, json) {
                    if (json && json.parent) {
                        if (json.parent.status !== rowMain.data().status) {
                            var newStatus = project_cell_status_render(null, null, json.parent, null);
                            LionBridgeConnectorGrid.projectTable.cell({ row: rowMain.index(), column: 4 }).data(newStatus);
                            var newAction = project_cell_action_render(null, null, json.parent, null);
                            LionBridgeConnectorGrid.projectTable.cell({ row: rowMain.index(), column: 5 }).data(newAction);
                        }
                    }
                }
            });
            LionBridgeConnectorGrid.assetsListTable[rowid] = assetsTable;

        }

        function project_cell_asset_log_link_render(data, type, row, meta) {
            var buttonGroup = '';
            if (row.assetUrl)
                buttonGroup = '<div class="btn-group"><button type = "button" class="btn btn-danger" onclick="LionBridgeConnectorJs.onEditProject(\'' + row.assetUrl + '\')"><span>View log</span></button></div >';
            else
                buttonGroup = '<div class="btn-group"><button disabled type = "button" class="btn btn-danger" onclick="LionBridgeConnectorJs.onEditProject(\'' + row.assetUrl + '\')"><span>View log</span></button></div >';
        
            return buttonGroup;
        };

        function asset_cell_action_render(data, type, row, meta) {
            var buttonGroup = '';
            var actions = row.allowActions;

            if (actions && actions != null) {
                buttonGroup = '<div class="btn-group">';
                for (var i = 0; i < actions.length; i++) {
                    var action = actions[i];

                    if (action == 3) {
                        buttonGroup += '<button type = "button" class="btn btn-danger" onclick="LionBridgeConnectorJs.onImportByLanguage(' + row.projectId + ',\'' + row.targetLanguages + '\', this)">Import</button>';
                    }
                    if (action == 4) {
                        buttonGroup += '<button type = "button" class="btn btn-danger" onclick="LionBridgeConnectorJs.onPublishByLanguage(' + row.projectId + ',\'' + row.targetLanguages + '\', this)">Publish</button>';
                    }
                }
                buttonGroup += '</div >';
            }

            return buttonGroup;
        };
        function asset_cell_name_render(data, type, row, meta) {
            return '<a href="javascript:void(0);">' + row.assets + '</a>' + (row.isError ? " <span class='dijitInline dijitIcon epi-iconError' title='" + row.serviceErrorMessage + "'></span>" : "");
        };
        //End Asset

        //Type: Type is child's Assets  : Project > Asset > Type
        $n('#project5b83a1a738dc42f4b697404c2d324450 tbody').on('click', 'td.project-language, td.detail-project-language', function () {
            //alert('asset click');

            var tr = $n(this).closest('tr');
            var row = LionBridgeConnectorGrid.assetsListTable[tr.attr('project-id')].row(tr);

            if (row.child.isShown()) {
                // This row is already open - close it
                destroyProjectAssets(row);
                tr.removeClass('shown');
            }
            else {
                // Open this row
                createProjectAssets(row, 'child-table'); // class is for background colour
                tr.addClass('shown');
            }
        });

        function destroyProjectAssets(row) {
            var table = $n("table", row.child());
            table.detach();
            table.DataTable().destroy();

            // And then hide the row
            row.child.hide();
        }

        function createProjectAssets(row) {
            var rowid = row.data().projectId;
            var targetLanguages = row.data().targetLanguages;
            // This is the table we'll convert into a DataTable
            var table = $n('<table style="width:95%; height: 100%; overflow: auto;" class="third-level"/>');
            var tableTemplate = $n('#pjasset25a496a334be4dc0b558af79b2d1946e');
            table.html(tableTemplate.html());

            // Display it the child row
            row.child(table).show();

            // Initialise as a DataTable
            var typesTable = table.DataTable({
                "processing": true,
                "serverSide": true,
                "orderCellsTop": true,
                //"fixedHeader": true,
                "searching": false,
                "autoWidth": false,
                "lengthChange": false,
                "pageLength": pageSize,
                "info": false,
                "ajax": {
                    "url": LionBridgeConnectorJs.projectAssetServiceUrl + rowid + "?language=" + targetLanguages,
                    "data": function (d) {
                        if (d.order.length > 0) {
                            d.ordercolumn = d.columns[d.order[0].column].data;
                            d.orderby = d.order[0].dir;
                        }
                        d.order = '';
                        d.columns = '';
                        d.search = '';
                    }
                },
                "columns": [
                    { "data": "type", "className": "project-language-asset" },
                    { "data": "name" },
                    { "data": "location" },
                    { "data": "link" },
                    { "data": "assetUrl" },
                ],
                "order": [[1, "desc"]],
                "columnDefs": [
                    {
                        "targets": [0],
                        "width": '5%'
                    },
                    {
                        "targets": [1],
                        "width": '20%'
                    },
                    {
                        "targets": [2],
                        "width": '20%'
                    },
                    {
                        "targets": [3],
                        "render": project_cell_asset_link_render,
                        "width": '30%'
                    },
                    {
                        "targets": [4],
                        "orderable": false,
                        "render": project_cell_asset_log_link_render,
                    }
                ],
                'createdRow': function (row, data, dataIndex) {
                    $n(row).attr('niteco-content-id', data.projectId);
                }
            });
        }

        function project_cell_asset_log_link_render(data, type, row, meta) {
            var buttonGroup = '';
            if (row.assetUrl)
                buttonGroup = '<div class="btn-group"><button type = "button" class="btn btn-danger" onclick="LionBridgeConnectorJs.onEditProject(\'' + row.assetUrl + '\')"><span>View log</span></button></div >';
            else
                buttonGroup = '<div class="btn-group"><button disabled type = "button" class="btn btn-danger" onclick="LionBridgeConnectorJs.onEditProject(\'' + row.assetUrl + '\')"><span>View log</span></button></div >';

            return buttonGroup;
        };

        function project_cell_asset_link_render(data, type, row, meta) {
            if (row.link === undefined || row.link === '')
                return '';

            return '<a href="' + row.link + '" rel="nofollow" target="_blank" status="' + row.status + '" assetId="' + row.assetID + '">' + row.link + '</a>';
        };

        //End Type

    }

    function destroy() {
        if ($.fn.DataTable.isDataTable("#project5b83a1a738dc42f4b697404c2d324450")) {
            LionBridgeConnectorGrid.projectTable.clear().destroy();
        }
    }

    function onReloadGrid() {
        if (LionBridgeConnectorGrid !== undefined && LionBridgeConnectorGrid.projectTable !== undefined) {
            LionBridgeConnectorGrid.projectTable.ajax.reload();
            LionBridgeConnectorGrid.projectTable.order([10, 'desc']).draw();
        }
    }

    function clearFilter() {
        var i = 0;
        $n('#project5b83a1a738dc42f4b697404c2d324450 thead tr:eq(0) th').each(function (i) {
            var input = $n('input', this);
            if (input !== undefined && input !== null && input.length !== 0) {
                if (input.val() !== '') {
                    input.val('');
                    LionBridgeConnectorGrid.projectTable.column(i).search(input.val()).draw();
                }
            }
            i++;
        });
    }

    function refreshChildGrid(item) {
        var table = $n(item).closest('table');
        if (table !== undefined)
            table.DataTable().ajax.reload();


    }

    function onToggleArchivingView(item) {
        var archiving = LionBridgeConnectorJs.onGetArchiving() === "true";
        archiving = !archiving;

        $n('#niteco-archive-all-button').attr('disabled', true);
        $n('#niteco-delete-all-button').attr('disabled', true);
        if ($n('#niteco-select-all-jobs').get(0) !== undefined)
            $n('#niteco-select-all-jobs').get(0).checked = false;
        while (LionBridgeConnectorGrid.listSelectJobs.length > 0) {
            LionBridgeConnectorGrid.listSelectJobs.pop();
        }

        if (item) {
            var archiveButton = document.getElementById(item.id);
            if (archiveButton) {
                if (archiving) {
                    archiveButton.innerHTML = LionBridgeConnectorConstant.viewUnarchivedJobs;
                } else {
                    archiveButton.innerHTML = LionBridgeConnectorConstant.viewArchivedJobs;
                }
            }
        }              

        LionBridgeConnectorJs.onSetArchiving(archiving);

        if (LionBridgeConnectorGrid !== undefined && LionBridgeConnectorGrid.projectTable !== undefined) {
            LionBridgeConnectorGrid.projectTable.ajax.url(LionBridgeConnectorJs.projectServiceUrl + archiving);
            LionBridgeConnectorGrid.onReloadGrid();
        }
    }

    function onRegisterClass() {
        var form = $n('#project5b83a1a738dc42f4b697404c2d324450').closest('form');
        if (!$n(form).hasClass('lb_dashboard'))
            $n(form).addClass('lb_dashboard');

        var body = $n('#project5b83a1a738dc42f4b697404c2d324450').closest('body');
        if (!$n(body).hasClass('lb_body_dashboard'))
            $n(body).addClass('lb_body_dashboard');
    }

    function registerEventDashboard() {
        $n('#niteco-select-all-jobs').on('click', function () {
            $n('#niteco-archive-all-button').attr('disabled', false);
            $n('#niteco-delete-all-button').attr('disabled', false);

            var rows = LionBridgeConnectorGrid.projectTable.rows({ 'search': 'applied' }).nodes();
            let items = $n('input[type="checkbox"]', rows);
            //$n('input[type="checkbox"]', rows).prop('checked', this.checked);
            //listSelectJobs = [];
            while (LionBridgeConnectorGrid.listSelectJobs.length > 0) {
                LionBridgeConnectorGrid.listSelectJobs.pop();
            }

            if (this.checked) {
                

                for (let i = 0; i < items.length; i++) {
                    $n(items[i]).get(0).checked = true;
                    if ($n(items[i]).attr('job-status') == LionBridgeConnectorConstant.inTranslation ||
                        $n(items[i]).attr('job-status') == LionBridgeConnectorConstant.readyForImport) {
                        $n('#niteco-delete-all-button').attr('disabled', true);
                    }
                    if ($n(items[i]).attr('job-status') == LionBridgeConnectorConstant.draft ||
                        $n(items[i]).attr('job-status') == LionBridgeConnectorConstant.sending) {
                        $n('#niteco-archive-all-button').attr('disabled', true);
                    }
                    LionBridgeConnectorGrid.listSelectJobs.push({ Id: $n(items[i]).attr('jobId'), Archive: $n(items[i]).attr('isArchive') });
                }
            } else {
                $n('#niteco-archive-all-button').attr('disabled', true);
                $n('#niteco-delete-all-button').attr('disabled', true);
                for (let i = 0; i < items.length; i++) {
                    $n(items[i]).get(0).checked = false;
                    if ($n(items[i]).attr('job-status') == LionBridgeConnectorConstant.inTranslation ||
                        $n(items[i]).attr('job-status') == LionBridgeConnectorConstant.readyForImport) {
                        $n('#niteco-delete-all-button').attr('disabled', true);
                    }
                    if ($n(items[i]).attr('job-status') == LionBridgeConnectorConstant.draft ||
                        $n(items[i]).attr('job-status') == LionBridgeConnectorConstant.sending) {
                        $n('#niteco-archive-all-button').attr('disabled', true);
                    }
                }
                while (LionBridgeConnectorGrid.listSelectJobs.length > 0) {
                    LionBridgeConnectorGrid.listSelectJobs.pop();
                }
            }

            if (LionBridgeConnectorJs.onGetArchiving() == 'true')
                $n('#niteco-archive-all-button').attr('disabled', true);

        });

        $n('tbody', LionBridgeConnectorGrid.projectTable.$).on('change', 'input[type="checkbox"]', function () {
            let id = $n(this).attr('jobId');
            let archive = $n(this).attr('isArchive');

            $n('#niteco-archive-all-button').attr('disabled', true);
            $n('#niteco-delete-all-button').attr('disabled', true);

            var rows = LionBridgeConnectorGrid.projectTable.rows({ 'search': 'applied' }).nodes();
            let items = $n('input[type="checkbox"]', rows);
            for (let i = 0; i < items.length; i++) {
                if ($n(items[i]).get(0).checked === true) {
                    $n('#niteco-archive-all-button').attr('disabled', false);
                    $n('#niteco-delete-all-button').attr('disabled', false);
                    break;
                }
            }           

            for (let i = 0; i < items.length; i++) {
                if ($n(items[i]).get(0).checked === true) {
                    if ($n(items[i]).attr('job-status') == LionBridgeConnectorConstant.readyForImport ||
                        $n(items[i]).attr('job-status') == LionBridgeConnectorConstant.inTranslation) {
                        $n('#niteco-delete-all-button').attr('disabled', true);
                    }
                    if (($n(items[i]).attr('job-status') == LionBridgeConnectorConstant.draft ||
                        $n(items[i]).attr('job-status') == LionBridgeConnectorConstant.sending)) {
                        $n('#niteco-archive-all-button').attr('disabled', true);
                    }
                }
            }

            if (!this.checked) {
                let el = $n('#niteco-select-all-jobs').get(0);
                // If "Select all" control is checked and has 'indeterminate' property
                if (el && el.checked && ('indeterminate' in el)) {
                    el.indeterminate = true;
                }
                LionBridgeConnectorGrid.listSelectJobs = LionBridgeConnectorGrid.listSelectJobs.filter((item) => item.Id != id);
            } else {
                LionBridgeConnectorGrid.listSelectJobs.push({ Id: id, Archive: archive });
            }
            if (LionBridgeConnectorJs.onGetArchiving() == 'true')
                $n('#niteco-archive-all-button').attr('disabled', true);
        });

    }

    return {
        onRenderGrid: onRenderGrid,
        assetsListTable: assetsListTable,
        projectTable: projectTable,
        destroy: destroy,
        onReloadGrid: onReloadGrid,
        clearFilter: clearFilter,
        refreshChildGrid: refreshChildGrid,
        onToggleArchivingView: onToggleArchivingView,
        onRegisterClass: onRegisterClass,
        registerEventDashboard: registerEventDashboard,
        listSelectJobs: listSelectJobs
    }

})();

