﻿define([
    "dojo",
    "dojo/query",
    "dojo/_base/declare",
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "epi/dependency",
    //custom
    "workspace/editors/knockout",
    "workspace/components/contenttypetree/contenttypetree"
    //"workspace/editors/knockoutmapping"
], function (
    dojo,
    query,
    declare,
    _Widget,
    _TemplatedMixin,
    dependency,
    //custom
    ko,
    ecorelioni
) {
    return declare("workspace.editors.contenttypetreeeditor.contenttypetreeeditor", [_Widget, _TemplatedMixin], {
        // templateString: [protected] String  
        //    A string that represents the default widget template.  
        //templateString: dojo.cache("workspace.editors", "MultiSelectEditor.template"),
        templateString: dojo.cache("workspace.editors.contenttypetreeeditor", "contenttypetreeeditor.html"),
        dialog: null,

        postCreate: function () {
            var registry = dependency.resolve("epi.storeregistry");
            ecorelioni = window["ecorelioni"];

            ecorelioni.init(this,
                registry.get("workspace.lioncontenttypestore"),
                registry.get("workspace.lionworkspacesettingstore"),
                ko);
        },

        focus: function () {
            // summary:  
            //    Put focus on this widget.  
            // tags:  
            //    public  

            dijit.focus(this.selected);
        },

        viewModel: {
            assets: ko.observableArray()
        },

        isValid: function () {
            // summary:  
            //    Indicates whether the current value is valid.  
            // tags:  
            //    public  

            return true;
        },

        onChange: function (value) {
            // summary:   
            //    Called when the value in the widget changes.   
            // tags:   
            //    public callback   
        },


        _onIntermediateChange: function (event) {
            // summary:   
            //    Handles the textbox key press events event and populates this to the onChange method.   
            // tags:   
            //    private   

            if (this.intermediateChanges) {
                this._set('value', event.target.value);
                this.onChange(this.value);
            }
        },

        _showContentTypes: function (event) {
            event.cancelBubble = true;

            ecorelioni.showDialog();
        },

        _onChange: function (event) {
            // summary:   
            //    Handles the textbox change event and populates this to the onChange method.   
            // tags:   
            //    private   

            this._set('value', event.target.value);
            this.onChange(this.value);
        },

        _setValueAttr: function (value) {
            // summary:   
            //    Sets the value of the widget to "value" and updates the value displayed in the textbox.   
            // tags:   
            //    private   

            this._set('value', value);
            this.selected.value = this.value || '';
        }
    });
});